/*
 * (C) Copyright 2005 NEC Electronics Corporation
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include "boot.h"
#include <config.h>

//; --- for MP200, system managemant unit
#define	SMU_BASE	        0xc8010000

#define	SMU_RESETCTRL0          0xc8010000
#define	SMU_RESETREQ0           0xc8010004
#define	SMU_RESETREQ0ENA        0xc8010008
#define	SMU_RESETREQ1           0xc801000c
#define	SMU_RESETREQ1ENA        0xc8010010
#define	SMU_GCLKCTRL0		0xC8010198
#define	SMU_GCLKCTRL0ENA	0xC801019C

#define	SMU_GCLKCTRL0ENA_VAL	0x0000000f

/*
 * Peripheral init flag
 */
#define		PERIPHERAL_INIT_BASE	0xa007f000
#define		PERIPHERAL_INIT_PE1	0xa007fd00
#define		PERIPHERAL_INIT_PE2	0xa007fd04
#define		PERIPHERAL_NOT_YET	0x00000000
#define		PERIPHERAL_EXECUTE	0x76000000
#define		PERIPHERAL_FINISH	0x00003200

/*
 * PE1/2 release reset
 */
	.set	REG_PID, 0x80000000
	.set	SDRAM_LIMIT, 0x34000000 

	.set	smu_s0_address_h1,	0xc8000000
	.set	smu_s0_address_h2,	0x00010000
	.set	smu_s0_resetreq0_l, 0x00000004
	.set	smu_s0_resetreq0ena_l, 0x00000008

BEGIN_FUNC (boot12)
	.global	boot12
	.set	BootFlagsAdrs, 0x40

	mov	r2, r0		/* r2 :	BootFlags */
	mov	r1, #REG_PID
	ldr	r0, [r1]	/* r0 :	PE ID */
	cmp	r0, #0
	bne	pe12

	SET_BASEREG(r0, PERIPHERAL_INIT_BASE)
	STORE_WORD(r0, PERIPHERAL_INIT_PE1, PERIPHERAL_FINISH, r1)
	STORE_WORD(r0, PERIPHERAL_INIT_PE2, PERIPHERAL_FINISH, r1)

	mov	r0, #SDRAM_LIMIT
	sub	r0, r0, #0x1000
	mov	r1, #12
	str	r1, [r0]
	ldr	r5, [r0]

	mov	r0, #0xFF00
	add	r0, r0, #0xFF
	ands	r4, r2, r0
	beq	boot12end

	.set	smu_PE1kaijo,  0x0000000c
	.set	smu_PE2kaijo,  0x00000030
	.set	smu_PE12kaijo, 0x0000003c

	.set	smu_PE1clockstopB, 0x00000003
	.set	smu_PE2clockstopB, 0x0000000c

	SET_BASEREG(r0, SMU_BASE)

	mov	r1, #0
	ands	r4, r2, #0x0000FF00
	addne	r1, r1, #smu_PE1kaijo
	ands	r4, r2, #0x00FF0000
	addne	r1, r1, #smu_PE2kaijo

        str     r1, [r0, #(SMU_RESETREQ0ENA & 0xfff)]
        str     r1, [r0, #(SMU_RESETREQ0 & 0xfff)]

#ifndef CONNECT_ICE
	mov	r1, #SMU_GCLKCTRL0ENA_VAL
	str	r1, [r0, #(SMU_GCLKCTRL0ENA & 0xfff)]
	
	ldr	r1, [r0, #(SMU_GCLKCTRL0 & 0xfff)]
	ands	r4, r2, #0x0000FF00
	biceq	r1, r1, #smu_PE1clockstopB
	ands	r4, r2, #0x00FF0000
	biceq	r1, r1, #smu_PE2clockstopB
	str	r1, [r0, #(SMU_GCLKCTRL0 & 0xfff)]

	mvn	r1, #0
	str	r1, [r0, #(SMU_GCLKCTRL0ENA & 0xfff)]
#endif
	
	ldr	r5, [r0, #(SMU_RESETREQ0 & 0xfff)]
	b	boot12end

pe12:
	cmp	r0, #1
	moveq	r5, #8
	movne	r5, #16
	mov	r4, r2, lsr r5
	mov	r3, #0xFF
	and	r4, r4, r3

	and	r7, r4, #0x0F
	and	r6, r4, #0xF0
	cmp	r6, #0
	bne	boot12end
	/* Flag=0X  no boot */
flag00:	nop
why0:	b	why0

	/* Flag=FX  boot */
boot12end:
	mov	pc, lr

END_FUNC (boot12)
