/*
 * (C) Copyright 2005 NEC Electronics Corporation
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include "boot.h"
#include "uwire.h"
#include <config.h>

#define TIMER_12MHZ_BOOT	// MP211 QueensES,MCT0501,GHIDORA

//; --- SRAM regin
#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM0
#define	WARM_BOOT_HANDLER_STACKBOTTOM0	0xa007fffc
#endif
#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM1
#define	WARM_BOOT_HANDLER_STACKBOTTOM1	0xa007fefc
#endif
#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM2
#define	WARM_BOOT_HANDLER_STACKBOTTOM2	0xa007fdfc
#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY0
#define	WARM_BOOT_HANDLER_ENTRY0	0xa007f000
#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY1
#define	WARM_BOOT_HANDLER_ENTRY1	0xa007f200
#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY2
#define	WARM_BOOT_HANDLER_ENTRY2	0xa007f400
#endif

#ifndef PE12_SUSPEND_FLAG
#define PE12_SUSPEND_FLAG		0xa009f1fc
#endif

#define PWC_PWR_CNT_HOLD_CLR		0x2a
#define PWC_PWR_CNT_HOLD_R		0x2b
#define	PWC_PWR_CNT_HOLD_R_LOGIC0_EN	0x1
#define	UWIRE_CS0			0

#define TI0_OP				0xC0000000
#define TI0_SET				0xC0000008
#define T0TIN_SEL			0xC801013C

/*
 * SyncBurst Mode flag
 */
#define SYNCBURST_MODE_ADDR	0xa007fa00
#define SYNCBURST_TRUE		0xffffffff
#define SYNCBURST_FALSE		0x00000000


void __attribute__ ((unused,section (".init.text")))
boot_check(void)
{
    register unsigned int self_pe __asm__ ("r0");

    /* check the number of PE */
    self_pe = *(unsigned int volatile *)0x80000000;
    if ( self_pe == 0 ) {

	/* check warmboot or not */
	if (uwire_check_resetcontrol() != 0) {
#ifdef TIMER_12MHZ_BOOT
	    register volatile unsigned int *base __asm__ ("r3");
	    base = (volatile unsigned int *)TI0_OP;
	    *base = 0x0;
	    base = (volatile unsigned int *)TI0_SET;
	    *base = (120000-1);
	    base = (volatile unsigned int *)T0TIN_SEL;
	    *base = 0x0;
	    base = (volatile unsigned int *)TI0_OP;
	    *base = 0x7;
#endif

	    uwire_init();
	    register unsigned int i __asm__ ("r3");
	    i = uwire_read(UWIRE_CS0, PWC_PWR_CNT_HOLD_R);
	    uwire_write(UWIRE_CS0, PWC_PWR_CNT_HOLD_CLR, 1);	/* VL1 CLR */
	    uwire_exit();
	    if ((i & PWC_PWR_CNT_HOLD_R_LOGIC0_EN) != 0 ) {
		/* warm boot */
	        __asm__ __volatile__ ("bl boot_pll_to_warmboot\t@ dispose old lr");
		i = *((volatile unsigned long *)SYNCBURST_MODE_ADDR);
		if ( i == SYNCBURST_TRUE ) {
		  __asm__ __volatile__ ("bl set_flash_burst\t@ dispose old lr");
		}
		__asm__ __volatile__ ("mov\tsp, %0\t@ stack base of warm boot"
			      :: "r" (WARM_BOOT_HANDLER_STACKBOTTOM0));
		__asm__ __volatile__ ("mov\tpc, %0\t@ jump to warm boot handler"
			      :: "r" (WARM_BOOT_HANDLER_ENTRY0));
	    } else {
	        /* cold boot */
	        __asm__ __volatile__ ("b init_checkfield_by_pe0\t@ keep old lr");
	    }
	    /* not reached */
	}
    }
}

