/*
 * (C) Copyright 2005-2006 NEC Electronics Corporation
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include "boot.h"
#include <config.h>

//; --- for MP200, system managemant unit
#define	SDRAM_BASE	        0x30000000
#define	SDRAM_SIZE_PAR_PE	0x01000000

BEGIN_RODATA (work_address_list)
	.word	SDRAM_BASE + (SDRAM_SIZE_PAR_PE * 4)	// 0x3400_0000-0x37df_ffff
	.word	SDRAM_BASE				// 0x3000_0000-0x31ff_ffff
	.word	SDRAM_BASE + (SDRAM_SIZE_PAR_PE	* 2)	// 0x3200_0000-0x32ff_ffff
	.word	-1
END_RODATA (work_address_list)

	.section	".init.text"
	.align		2
	.type		work_address_list_ptr,object
work_address_list_ptr:
	.word		work_address_list

	.set	REG_PID, 0x80000000

BEGIN_INIT_FUNC (get_work_address)
	ldr	r10, work_address_list_ptr
	ldr	r11, [r10]
	mov	r1, #REG_PID
	ldr	r0, [r1]
	cmp	r0, #0
	bne	pe12
	b	get_work_addressend

pe12:
	ldr	r11, [r10, #4]
	cmp	r0, #1
	bne	pe2
	b	get_work_addressend

pe2:
	ldr	r11, [r10, #8]
	b	get_work_addressend

get_work_addressend:
	mov	pc, lr

END_INIT_FUNC (get_work_address)
