/*
 * (C) Copyright 2005 NEC Electronics Corporation
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#ifndef BOOT_H
#define BOOT_H

/* 2006.06.09 fuj : For NAND boot */
#include <config.h>

#ifdef __ASSEMBLER__

#define BEGIN_FUNC(X)	\
	.text;\
	.align	2;\
	.type	X,function;\
	X:

#define END_FUNC(X)	\
	.size	X,.-X

/* 2006.06.09 fuj : For NAND boot */
#if defined(CONFIG_ICX1087) && defined(CONFIG_NANDBOOT)
#define BEGIN_INIT_FUNC(X)  \
    .text;\
    .align  2;\
    .type   X,function;\
    .globl          X;\
    X:
#else
#define BEGIN_INIT_FUNC(X)	\
	.section ".init.text";\
	.align		2;\
	.type		X,function;\
	.globl          X;\
	X:
#endif  /* CONFIG_ICX1087 && CONFIG_NANDBOOT */

#define END_INIT_FUNC(X) END_FUNC(X)

#define BEGIN_RODATA(X) \
	.section	.rodata;\
	.align	2;\
	.type	X,object;\
	X:

#define END_RODATA(X)	END_FUNC(X)

#define	SET_BASEREG(base_reg, VALUE)	\
        MOV     base_reg, #((VALUE) & 0xff000000);		\
	.ifne ((VALUE) & 0x00ff0000); \
        ADD     base_reg, base_reg, #((VALUE) & 0x00ff0000);	\
	.endif; \
	.ifne ((VALUE) & 0x0000ff00); \
        ADD     base_reg, base_reg, #((VALUE) & 0x0000ff00);	\
	.endif; \
	.ifne ((VALUE) & 0x000000ff); \
        ADD     base_reg, base_reg, #((VALUE) & 0x000000ff); \
	.endif;

#define	STORE_WORD(base_reg, OFFSET, VALUE, work_reg)	\
        MOV     work_reg, #((VALUE) & 0xff000000);		\
	.ifne ((VALUE) & 0x00ff0000); \
        ADD     work_reg, work_reg, #((VALUE) & 0x00ff0000);	\
	.endif; \
	.ifne ((VALUE) & 0x0000ff00); \
        ADD     work_reg, work_reg, #((VALUE) & 0x0000ff00);	\
	.endif; \
	.ifne ((VALUE) & 0x000000ff); \
        ADD     work_reg, work_reg, #((VALUE) & 0x000000ff);	\
	.endif; \
        STR     work_reg, [base_reg, #((OFFSET) & 0x00fff)];
	

#else /* __ASSEMBLER__ */

#endif /* __ASSEMBLER__ */

#endif /* BOOT_H */
