/*
 * bios_nand.c
 *
 * Copyright 2006,2007 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

/* 2006.05.10 fuj */
#include <common.h>
#ifdef CONFIG_ICX1087

/* 2006.05.10 fuj */
#include "bios_nand.h"
#include "bios_gio.h"
/* #include "bios.h" */
#include "nand_local.h"
#include "nand_config.h"

#define outl(data,addr) *(volatile unsigned long*)(addr) = (data)
#define inl(addr) *(volatile unsigned long*)(addr)

/* 2006.05.10 fuj */
#define	NAND_DELAY_US	15
#define NAND_WAIT_CACT()	udelay(NAND_DELAY_US);\
							while( inl(NAND_FRD) & NAND_FRD_CACT )	/* CPU Bus Busy */

/* õȽ񤭹ߤԤ֤ԤĤΥХåؿơ֥ */
/* ϿƤʤϡݡ󥰤Ԥ */
static NAND_CB_FUNC nandCbFunc = {NULL, NULL};
/* 2006.05.10 fuj */
static int icx1087_nand_init = 0;

/* 2007.04.27 fuj */
#ifdef CONFIG_ICX1111
static int partCount = 0;
void nandSetPageSize(int size)
{
	unsigned long msr_reg;

	partCount = size >> 9;		/* 2K = 4; 4K = 8 */

	msr_reg = inl(NAND_MSR);
	msr_reg &= ~NAND_MSR_PSIZE_MASK;
	if (partCount == 8)
		msr_reg |= NAND_MSR_PSIZE_4096;		/* 4094B/page */
	else
		msr_reg |= NAND_MSR_PSIZE_2048;		/* 2048B/page */

	outl(msr_reg, NAND_MSR);
}
#endif

static unsigned long READ_NAND(void)
{
	unsigned long frd;
	outl(0, NAND_BDRR);
	while (1) { // å뤵ƤФĤȴ
		frd = inl(NAND_FRD);
		if (!(frd & NAND_FRD_CACT)) {
			break;
		}
	}
	return frd & NAND_FRD_DATA_MASK;
}

static int nand_send_cmd(unsigned command);

/* 2007.04.17 fuj */
#ifdef CONFIG_ICX1111
void nandInitialize(NAND_CB_FUNC *p, unsigned char *id)
#else
void nandInitialize(NAND_CB_FUNC *p)
#endif
{
/* 2007.04.17 fuj */
#ifndef CONFIG_ICX1111
/* 2006.09.28 fuj : Apply SAMSUNG chip */
	unsigned char buf_id[8];
#endif

/* 2006.05.10 fuj */
	if(icx1087_nand_init != 0)
		return;
	icx1087_nand_init = 1;

	if( p != NULL )nandCbFunc = *p;

/* 2007.04.27 fuj */
#ifdef CONFIG_ICX1111
	if( partCount == 0 )
		partCount = 4;
#endif

	/* NAND chip Power on */
	/* T.B.D */

	/* wait NAND chip power on */
	/* T.B.D */

	/* pin func = NAND, data[15-8] = GPIO, CSZ[3-1]=Hiz */
	outl(SMU_PCTL_NAND_8BIT, SMU_PCTL_NAND);

	/* data[15-8],RBZ3-1 pullup */
/* 2007.03.07 fuj : Applied not to use NAND_XWP */
#ifndef CONFIG_ICX1111
	outl(SMU_PULLCTL_NAND_8BIT, SMU_PULLCTL_NAND);
#endif
	/* NAND bus drive */
	outl(NAND_MSR_INIT, NAND_MSR);  /* 2048B/page  8bit width */
#ifdef NAND_SUPPORT_EDO
	outl( 1,            NAND_CR); /* EDO */
	NAND_ENABLE_CE(0);
	nand_send_cmd(NAND_CMD_EDO);
	NAND_DISABLE_CE(0);
#endif
/* 2007.03.07 fuj : Applied not to use NAND_XWP */
#ifndef CONFIG_ICX1111
/* 2006.05.10 fuj */
	BIOS_MCR_OUTPH(GPIO_GPIO2_EO, GPIO_GPIO2_WP);		/* GPIO47 set to output */
	BIOS_MCR_OUTPW(GPIO_GPIO2_DO,						/* WP = H */
				   (GPIO_GPIO2_WP<<16)|(GPIO_GPIO2_WP&0xFFFF));
/*	gpioPortSetup(GPIO_NAND_WP, GPIO_PORT_TYPE_OUT); */
/*	gpioPortWriteBit(GPIO_NAND_WP, 1);				 */ /* WP = H */
#endif	/* CONFIG_ICX1111 */

/* 2007.04.12 fuj : for ICX1111(Applied HYNIX chip) */
/* 2006.09.28 fuj : Apply SAMSUNG chip */
/* 2007.04.17 fuj */
#ifdef CONFIG_ICX1111
	if(nandReadId(0, id) == 0) {
		if(id[0] == NAND_MID_TOSHIBA)
			outl(NAND_MSR_TOSHIBA, NAND_MSR); 
		else if(id[0] == NAND_MID_SAMSUNG)
			outl(NAND_MSR_SAMSUNG, NAND_MSR); 
		else if(id[0] == NAND_MID_HYNIX)
			outl(NAND_MSR_HYNIX, NAND_MSR); 
	}
#else
	if(nandReadId(0, buf_id) == 0) {
		if(buf_id[0] == NAND_MID_TOSHIBA)
			outl(NAND_MSR_TOSHIBA, NAND_MSR); 
		else if(buf_id[0] == NAND_MID_SAMSUNG)
			outl(NAND_MSR_SAMSUNG, NAND_MSR); 
		else if(buf_id[0] == NAND_MID_HYNIX)
			outl(NAND_MSR_HYNIX, NAND_MSR); 
	}
#endif
	/* in case of invalid ID, use default parameter */
}

static int
nand_send_cmd(unsigned command)
{
	int i;
	switch (command) {
	case NAND_CMD_READ0:
	case NAND_CMD_EDO:
		outl(command, NAND_CWR);
/* 2006.05.10 fuj */
		NAND_WAIT_CACT();
		break;
	case NAND_CMD_STATUS:
		outl(command, NAND_CWR);
/* 2006.05.10 fuj */
		NAND_WAIT_CACT();
		for ( i = NAND_READ_TIMEOUT; i > 0; i-- ) {
			if (READ_NAND() & NAND_STATUS_READY) {
				return 0;
			}
		}
		return BIOS_ERR_TIMEOUT;
	case NAND_CMD_READID:
		outl(command, NAND_CWR);
/* 2006.05.10 fuj */
		NAND_WAIT_CACT();
		outl(0, NAND_LAWR);
/* 2006.05.10 fuj */
		NAND_WAIT_CACT();
		break;
	case NAND_CMD_RESET:
		outl(command, NAND_CWR);
/* 2006.05.10 fuj */
		NAND_WAIT_CACT();
		/* check status ready/busy */
		return nand_send_cmd(NAND_CMD_STATUS);
	default:
		/* unsupport command */
		break;
	}
	return 0;
}

static int           /* offset < 0 ǾĹ */
nand_correct_data(unsigned long dest, int offset)
{
	unsigned long ERR_VAL = NAND_RSEVxR;
	unsigned long ERR_PLA = NAND_RSEPxR;
	unsigned long rs_status;
	unsigned int pla, val;
	unsigned long cor_adr;
	unsigned char cor_val;
	int i;

	rs_status = inl(NAND_RSSR) & NAND_RSSR_MASK;

	if (rs_status == RS_NO_ERROR) {
		return 0;	/* no error */
	}
	if (rs_status == RS_UNCORRECT_ERROR) {
		return -1;	/* uncorrectable error */
	}
	for (i = 0; i <= 3; i++) {
		pla = inl(ERR_PLA);
		val = inl(ERR_VAL);
		if (pla > 0x0d) {
			/* data field error. */
			if (val > 0xff) {
				return -1;
			} else if(offset >= 0){
				cor_adr = ((dest + offset) + 0x20d - pla);
				cor_val =
					(*(volatile unsigned char *)(cor_adr));
				cor_val ^= val;
				(*(volatile unsigned char *)(cor_adr)) =
					cor_val;
			}
		} else if (pla > 0x07) {
			/* spare field error. */
			if (val > 0xff) {
				return -1;
			} else if(offset < 0){
				cor_adr = ((dest + offset) + 0x00d - pla);
				cor_val =
					(*(volatile unsigned char *)(cor_adr));
				cor_val ^= val;
				(*(volatile unsigned char *)(cor_adr)) =
					cor_val;
			}
		} else if (!((pla == 0x0) && (i != 0))) {
			/* RS field error. ignored. */
			cor_adr = pla;
		} else {  /* pla == 0 && i != 0 */
			/* no more error */
			break;
		}
		ERR_PLA += 0x4;
		ERR_VAL += 0x4;
	}
	return 0;
}

int nandReadPage(
  unsigned char ce,     /* CEֹ 0-3 */
  unsigned long page,   /* ˥ڡɥ쥹 24bit */
  void *dest,           /* ХåեΥɥ쥹 4byte */
  unsigned char *ext)   /* Ĺ 6byte */
{
	unsigned long pointer;
	unsigned int offset, psc_step;
	unsigned long msr, ipr, status;
	unsigned short etmp, blank;
	int uncorrect, i;
	int needSpareChk = 0;

	if( ce > 3 ) return BIOS_ERR_PARAM;
	ce = 1 << ce;
	/* set destination address(SRAM address) */
	outl((unsigned long)dest, NAND_ATBAR);

	/* setting PSC sequence command */
	PSC_CMD_SET_BEGIN();

	/* CEZ_OUT0 = '0' */
	PSC_CMD_SET(PSC_CMD_CESEL, ce ^ 0x0F);

	/* Read command(00h) */
	PSC_CMD_SET(PSC_CMD_OUTCMD, NAND_CMD_READ0);

	/* send address command */
	PSC_CMD_SET(PSC_CMD_OUTADRS, 0);
	PSC_CMD_SET(PSC_CMD_OUTADRS, 0);
	PSC_CMD_SET(PSC_CMD_OUTADRS, (page & 0xff));
	PSC_CMD_SET(PSC_CMD_OUTADRS, ((page >> 8) & 0xff));
	PSC_CMD_SET(PSC_CMD_OUTLTADRS, ((page >> 16) & 0xff)); /* 128MBξϥǥХˤä̵뤵 */
	/* read start command */
	PSC_CMD_SET(PSC_CMD_OUTCMD, NAND_CMD_READSTART);
    /* wait busy */
    PSC_CMD_SET(PSC_CMD_WAITBUSY, ce);
    /* wait ready */
    PSC_CMD_SET(PSC_CMD_WAITRDY, ce);

	/* PSC sequence stop command */
	PSC_CMD_SET(PSC_CMD_STOPINT, PSC_IIDR_ADR_SEND);

	PSC_CMD_SET_END();

	outl(LDMA_INT_MASK, NAND_LICR);

	/* start PSC sequence */
	outl(PSC_START, NAND_PSCR);

	/* wait PSC sequence end */
	i = NAND_READ_TIMEOUT;
	while (!(inl(NAND_LIRSR) & LDMA_INT_PSC)) {
		if(--i <= 0){    /*  timeoutʤȡIPꥻåȤʤǤʤʤ */
			/* STOP PSC */
			outl(0, NAND_PSCR);
			/* disable CE */
			outl(0x0F, NAND_CECR);
			return BIOS_ERR_TIMEOUT;
		}
	}

	/* setting PSC sequence command */
	PSC_CMD_SET_BEGIN();

	/* Local DMA start command */
/* 2007.04.27 fuj */
#ifdef CONFIG_ICX1111
	for (i = partCount; i > 0; i--) {
#else
	for (i = 4; i > 0; i--) {
#endif
		PSC_CMD_SET(PSC_CMD_DMAST, PSC_DMA_START);
		PSC_CMD_SET(PSC_CMD_WAITTC, PSC_DMA_RSOK);
	}
	/* PSC sequence stop command */
	PSC_CMD_SET(PSC_CMD_STOPINT, PSC_IIDR_DMA_END);

	PSC_CMD_SET_END();

	outl(LDMA_INT_MASK, NAND_LICR);

	/* AHB Master trans start */
	msr = inl(NAND_MSR);
	msr |= (NAND_MSR_AHBDIR | NAND_MSR_AHBMEN);	/* Master write and enable */
	outl(msr, NAND_MSR); /* DMAenableˤ顢ǸޤǼ¹ԤʤȤʤ */

	/* start PSC sequence */
	outl(PSC_START, NAND_PSCR);
	uncorrect = 0;
	i = NAND_READ_TIMEOUT;
	while (1) {
		status = inl(NAND_LIRSR);
		if (status & LDMA_INT_PSC) {
			/* PSC complete */
			/* LDMA INT status clear */
			outl((LDMA_INT_RSOK | LDMA_INT_PSC | LDMA_INT_LDMACTC), NAND_LICR);
			/* wait AHB trans */
			while (!(inl(NAND_INTRAWSTATUS) & BBC_INT_PAGEINT)) {
				;
			}
			/* BBC INT status clear */
			outl(BBC_INT_MASK, NAND_INTFFCLR);
			/* trans OK */
			break;
		} else if (status & LDMA_INT_RSERR) {
			/* PSC abort(RS error) */
			/* wait RS calculate */
			while (!(inl(NAND_RSSR) & NAND_RSSR_CALC_END)) {
				;
			}
			/* LDMA INT status all clear */
			outl(LDMA_INT_MASK, NAND_LICR);
			/* wait AHB trans */
			while (!
			       (inl(NAND_INTRAWSTATUS) &
				(BBC_INT_PAGEINT | BBC_INT_512INT))) {
				;
			}
			/* BBC INT status all clear */
			outl(BBC_INT_MASK, NAND_INTFFCLR);

			/* correct data */
			ipr = inl(NAND_IPR);
			offset = RS_CHECK_SIZE * ((ipr / 2) - 1);
			if (nand_correct_data((unsigned long)dest, offset)) {
				uncorrect = 1;	/* uncorrectable error */
			}
			/* last sequence ? */
			if (ipr == PSC_SEQUENCE_END) {
				needSpareChk = 1;
				break;
			} else {
				/* restart PSC sequence */
				outl(PSC_START, NAND_PSCR);
			}
		}
	}
	outl(0x0F, NAND_CECR);

/* Ĺ٤0xFFξECC顼ʤäȤˤ */
	/* set spare data */
	blank = 0xffff;
	for( i = 0; i < 12; i += 4 ){
		etmp = inl( NAND_SDH0R + i );
		blank &= etmp;
		if(ext){
			*ext++ = etmp;
			*ext++ = etmp >> 8;
		}
	}
	if(needSpareChk && ext) nand_correct_data((unsigned long)ext,-6 );
   /* for RS ECC read */
	for( i = 0; i < 20; i+=4 ){
		etmp = inl( NAND_SDH3R + i );
		blank &= etmp;
	}
	blank &= etmp;
	if( blank == 0xFFFF ) uncorrect = 0;
	return uncorrect;
}

/* Ĺ6byte꤬ɬ */
int nandWritePage(
  unsigned char ce,     /* CEֹ 0-3 */
  unsigned long page,   /* ˥ڡɥ쥹 24bit */
  void *dest,           /* ХåեΥɥ쥹 4byte */
  unsigned char *ext)   /* Ĺ 6byte */
{
	unsigned long pointer;
	unsigned int psc_step;
	unsigned long msr;
	int i;
	if( ce > 3 ) return BIOS_ERR_PARAM;
	ce = 1 << ce;

	/* set spare data */
	outl( ext[0] | ext[1] << 8, NAND_SDH0R );
	outl( ext[2] | ext[3] << 8, NAND_SDH1R );
	outl( ext[4] | ext[5] << 8, NAND_SDH2R );

	/* set destination address(SRAM address) */
	outl((unsigned long)dest, NAND_ATBAR);

	/* setting PSC sequence command */
	PSC_CMD_SET_BEGIN();

	/* CEZ_OUT0 = '0' */
	PSC_CMD_SET(PSC_CMD_CESEL, ce ^ 0x0F);

	/* DATAIN command(80h) */
	PSC_CMD_SET(PSC_CMD_OUTCMD, NAND_CMD_DATAIN);

	/* send address command */
	PSC_CMD_SET(PSC_CMD_OUTADRS, 0);
	PSC_CMD_SET(PSC_CMD_OUTADRS, 0);
	PSC_CMD_SET(PSC_CMD_OUTADRS, (page & 0xff));
	PSC_CMD_SET(PSC_CMD_OUTADRS, ((page >> 8) & 0xff));
	PSC_CMD_SET(PSC_CMD_OUTLTADRS, ((page >> 16) & 0xff));/* 128MBξϥǥХˤä̵뤵 */

	/* AHB Master trans start */
	msr = inl(NAND_MSR);
	msr |= (NAND_MSR_AHBMEN);	/* Master write and enable */
	msr &= ~NAND_MSR_AHBDIR;
	outl(msr, NAND_MSR);

	/* Local DMA start command */
/* 2007.04.27 fuj */
#ifdef CONFIG_ICX1111
	for (i = partCount; i > 0; i--) {
#else
	for (i = 4; i > 0; i--) {
#endif
		PSC_CMD_SET(PSC_CMD_DMAST, PSC_DMA_START);
		PSC_CMD_SET(PSC_CMD_WAITTC, PSC_DMA_);
	}

	/* program command() */
	PSC_CMD_SET(PSC_CMD_OUTCMD, NAND_CMD_PROGRAM);
    /* wait busy */
    PSC_CMD_SET(PSC_CMD_WAITBUSY, ce);
    /* wait ready */
    PSC_CMD_SET(PSC_CMD_WAITRDY, ce);
    /* status read */
	PSC_CMD_SET(PSC_CMD_CHKST, NAND_CMD_STATUS);

	/* PSC sequence stop command */
	PSC_CMD_SET(PSC_CMD_STOPINT, PSC_IIDR_ADR_SEND);

	PSC_CMD_SET_END();

	outl(LDMA_INT_MASK, NAND_LICR);

	/* start PSC sequence */
	outl(PSC_START, NAND_PSCR);

	/* wait PSC sequence end */
	if(nandCbFunc.write == NULL){ /* Хåʤ */
		i = NAND_WRITE_TIMEOUT;
		while (!(inl(NAND_LIRSR) & LDMA_INT_PSC)) {
			if(--i <= 0){
				goto timeout;
			}
		}
	}else{
		if(nandCbFunc.write()){
			goto timeout;
		}
	}
	/* disable CE */
	outl(0x0F, NAND_CECR);
	return inl(NAND_FWSR) & 1;

timeout:
	/* STOP PSC */
	outl(0, NAND_PSCR);
	/* disable CE */
	outl(0x0F, NAND_CECR);
	return BIOS_ERR_TIMEOUT;
}


int nandEraseBlock(
  unsigned char ce,   /* CEֹ 0-3 */
  unsigned long page) /* ˥ڡɥ쥹 24bit 6bit(SLC)ޤ7bit(MLC)̵ */
{
	unsigned long pointer;
	unsigned int psc_step;
	int i;

	if( ce > 3 ) return BIOS_ERR_PARAM;
	ce = 1 << ce;
	/* setting PSC sequence command */
	PSC_CMD_SET_BEGIN();

	/* CEZ_OUT0 = '0' */
	PSC_CMD_SET(PSC_CMD_CESEL, ce ^ 0x0F);

	/* erase0 command() */
	PSC_CMD_SET(PSC_CMD_OUTCMD, NAND_CMD_ERASE0);

	/* send address command */
	PSC_CMD_SET(PSC_CMD_OUTADRS, (page & 0xff));
	PSC_CMD_SET(PSC_CMD_OUTADRS, ((page >> 8) & 0xff));
	PSC_CMD_SET(PSC_CMD_OUTLTADRS, ((page >> 16) & 0xff));  /* 128MBξϥǥХˤä̵뤵 */

	/* erase1 command() */
	PSC_CMD_SET(PSC_CMD_OUTCMD, NAND_CMD_ERASE1);
    /* wait busy */
    PSC_CMD_SET(PSC_CMD_WAITBUSY, ce);
    /* wait ready */
    PSC_CMD_SET(PSC_CMD_WAITRDY, ce);
    /* status read */
	PSC_CMD_SET(PSC_CMD_CHKST, NAND_CMD_STATUS);

	/* PSC sequence stop command */
	PSC_CMD_SET(PSC_CMD_STOPINT, PSC_IIDR_ADR_SEND);

	PSC_CMD_SET_END();

	outl(LDMA_INT_MASK, NAND_LICR);

	/* start PSC sequence */
	outl(PSC_START, NAND_PSCR);

	/* wait PSC sequence end */
	if(nandCbFunc.erase == NULL){ /* Хåʤ */
		i = NAND_WRITE_TIMEOUT;
		while (!(inl(NAND_LIRSR) & LDMA_INT_PSC)) {
			if(--i <= 0){
				goto timeout;
			}
		}
	}else{
		if(nandCbFunc.erase()){
			goto timeout;
		}
	}
	/* disable CE */
	outl(0x0F, NAND_CECR);
	return inl(NAND_FWSR) & 1;

timeout:
	/* STOP PSC */
	outl(0, NAND_PSCR);
	/* disable CE */
	outl(0x0F, NAND_CECR);
	return BIOS_ERR_TIMEOUT;
}

int nandReadId( unsigned char ce, unsigned char *pbuf )
{
	int i;

	if( ce > 3 ) return BIOS_ERR_PARAM;
	/* chip select enable */
	NAND_ENABLE_CE(ce);

	/* Reset the chip */
	i = nand_send_cmd(NAND_CMD_RESET);
	if(i){ /* ĤʤäƤʤȥॢȤ */
		NAND_DISABLE_CE(ce);
		return i;
	}

	/* Read the NAND chip ID */
	nand_send_cmd(NAND_CMD_READID);

	for( i = 0; i < 5; i++ ){
		*pbuf++ = READ_NAND();
	}

	NAND_DISABLE_CE(ce);
	return 0;
}

#endif	/* CONFIG_ICX1087 */

/* END */
