/*
 * bios_nand.h
 *
 * Copyright 2006,2007 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __BIOS_NAND_H__
#define __BIOS_NAND_H__

#include "bios_common.h"

typedef struct 
{
	int (*write)(void); /* write(program)ԤΤΥХåؿ timeout0ʳ֤ */
	int (*erase)(void); /* eraseԤΤΥХåؿ timeout0ʳ֤ */
} NAND_CB_FUNC;

int nandReadPage(unsigned char ce, unsigned long page, void *dest, unsigned char *ext);
int nandWritePage(unsigned char ce, unsigned long page, void *dest, unsigned char *ext);
int nandEraseBlock(unsigned char ce, unsigned long page);
int nandReadId(unsigned char ce, unsigned char *buf);
/* 2007.04.17 fuj */
#ifdef CONFIG_ICX1111
void nandInitialize( NAND_CB_FUNC*, unsigned char* );
void nandSetPageSize(int size);
#else
void nandInitialize( NAND_CB_FUNC* );
#endif

#endif /* __BIOS_NAND_H__ */
