/*
 * bios_pwm.h
 *
 * Copyright 2006,2007 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef _BIOS_PWM_H_
#define _BIOS_PWM_H_

#include "bios_common.h"


/*---------------------------- user setting --------------------------*/
#define	PWM_BL_MIN			0
#define	PWM_BL_MAX			100

/* prototype */
extern void pwmInit( void );
/* 2007.05.30 fuj : Applied RTC wake-up */
#ifdef CONFIG_ICX1111
extern void pwmExit( void );
#endif
extern void pwmStart( void );
extern void pwmStop( void );
extern void pwmSetValue( int );


/*---------------------------- LCD register --------------------------*/
/* register address */
#define	PWM_CH1_CTRL		0xC0060100
#define	PWM_CH1_MODE		0xC0060104
#define	PWM_CH1_DELAY0		0xC0060110
#define	PWM_CH1_LEDGE0		0xC0060114
#define	PWM_CH1_TEDGE0		0xC0060118
#define	PWM_CH1_TOTAL0		0xC006011C
#define	PWM_CH1_LOOP0		0xC0060120

#define	PWM_INTENSET		0xC0060408
/* not use others */

/* default */
#define PWM_MODE			0x00000001
#define PWM_DELAY			5				/* Delay 5 cycles		  */
										/* (referenced Kernel driver) */
#define PWM_TOTAL			1200			/* 10kHz 				  */
#define	PWM_FULL			844				/* Lv.5(full) in Linux	  */
#define	PWM_TEDGE			(PWM_TOTAL)
#define	PWM_LEDGE			0
#define PWM_START			0x00000001
#define PWM_STOP			0x00000000

#endif    /* _BIOS_PWM_ */

