/*
 * (C) Copyright 2005-2006 NEC Electronics Corporation
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#include "boot.h"
#include <config.h>

#ifdef CONFIG_MP201
#ifdef CONFIG_MP201_ES10
# define PROV_BOOT  /* provisional boot */
#else
//#define	PROV_BOOT	/* provisional boot */
#endif
//#define MP201EL_BD

/* define clock */
//#define CPU_48M		/* SDRAM  48MHz (HPLL= 96MHz) */
//#define CPU_124M	/* SDRAM 124MHz (HPLL=248MHz) */

#ifdef	CPU_48M
# define	PLL_48MHZ
#else
# ifdef	CPU_124M
#  define	PLL_124MHZ
# else

#ifdef	CONFIG_MP200_PLL
# if	( CONFIG_MP200_PLL == 192 )
#  define	PLL_192MHZ
# else
#  if	( CONFIG_MP200_PLL == 248 )
#   define	PLL_248MHZ
#  else
#   error
#  endif
# endif
#endif

# endif
#endif

//; --- for MP201, system managemant unit
#define	SMU_BASE	        0xC8010000

#define	SMU_RESETREQ0           0xC8010000
#define	SMU_RESETREQ0ENA        0xC8010010
#define	SMU_RESETREQ1A          0xC8010004
#define	SMU_RESETREQ1AENA       0xC8010014
#define	SMU_RESETREQ1B          0xC8010008
#define	SMU_RESETREQ1BENA       0xC8010018
#define	SMU_RESETREQDSP         0xC801000C
#define	SMU_RESETREQDSPENA      0xC801001C

/* base address and range registers for Chip Select 0 to 3 */
/* for I/O or memory devices */
#define	SMU_AB0_CS0BASEADD	0xC8010300
#define	SMU_AB0_CS1BASEADD	0xC8010304
#define	SMU_AB0_CS2BASEADD	0xC8010308
#define	SMU_AB0_CS3BASEADD	0xC801030C
#define	SMU_AB0_CS0BITCOMP	0xC8010310
#define	SMU_AB0_CS1BITCOMP	0xC8010314
#define	SMU_AB0_CS2BITCOMP	0xC8010318
#define	SMU_AB0_CS3BITCOMP	0xC801031C

/* Chip Select for Flash Memories */
/* access to address range 0x00000000-0x03FFFFFF asserts CS0 */
#define	SMU_AB0_CS0BASEADD_VAL	0x00000000
/* 2006.03.07 fuj (NOR FLASH) */
#ifdef CONFIG_ICX1087
#define	SMU_AB0_CS0BITCOMP_VAL	0xFF000000
#else
#define	SMU_AB0_CS0BITCOMP_VAL	0xFC000000
#endif /* CONFIG_ICX1087 */

#ifndef	CONFIG_MP200_MINI_BOARD
/* Chip Select for EBC/FPGA itself */
/* access to address range 0x203E0000-0x203EFFFF asserts CS1 */
# define SMU_AB0_CS1BASEADD_VAL_DEF	0x2FFE0000
# define SMU_AB0_CS1BASEADD_VAL		0x203E0000
# define SMU_AB0_CS1BITCOMP_VAL		0xFFFF0000

/* Chip Select for PCMCIA */
/* access to address range 0x08100000-0x0FFFFFF asserts CS2 */
#define	SMU_AB0_CS2BASEADD_VAL	0x08100000
#define	SMU_AB0_CS2BITCOMP_VAL	0xFE000000

/* Chip Select for Ether/Wireless LAN/MA-3D/D9930 */
/* access to address range 0x20000000-0x2007FFFF asserts CS3 */
#define	SMU_AB0_CS3BASEADD_VAL	0x20000000
#define	SMU_AB0_CS3BITCOMP_VAL	0xFFF80000
#else	/* define CONFIG_MP200_MINI_BOARD */
/* Chip Select for Ether/Wireless LAN/MA-3D/D9930 */
/* access to address range 0x20000000-0x2007FFFF asserts CS1 */
# define SMU_AB0_CS1BASEADD_VAL	0x20000000
# define SMU_AB0_CS1BITCOMP_VAL	0xFFF80000

/* 2006.10.17 fuj (EPSON_USB) */
#ifdef CONFIG_ICX1087
/* access to address range 0x20080000-0x200FFFFF asserts CS2 */
# define SMU_AB0_CS2BASEADD_VAL	0x20080000
# define SMU_AB0_CS2BITCOMP_VAL	0xFFF00000
#endif
#endif	/* define CONFIG_MP200_MINI_BOARD */

/* timing registers for Chip Select 0 to 3 */
/* for I/O or memory devices */
#define	SMU_AB0_CS0WAITCTL	0xC8010320		// flash region
#define	SMU_AB0_CS1WAITCTL	0xC8010324
#define	SMU_AB0_CS2WAITCTL	0xC8010328
#define	SMU_AB0_CS3WAITCTL	0xC801032C
#define SMU_AB0_CS0WAITCTL_W	0xC8010344		// flash region
#define SMU_AB0_CS1WAITCTL_W	0xC8010348
/* 2006.10.18 fuj */
#define SMU_AB0_CS2WAITCTL_W	0xC801034C
#define SMU_AB0_CS3WAITCTL_W	0xC8010350

#define SMU_AB0_CS0READCTRL		0xC8010330		// flash region
#define SMU_AB0_CS1READCTRL		0xC8010334
#define SMU_AB0_CS2READCTRL		0xC8010338
#define SMU_AB0_CS3READCTRL		0xC801033C

#define SMU_AB0_FLASHCLKCTRL	0xC8010340

//;;; --- for SDRAM control
	
#define	FIF_SDR_BASE		0x4C001000
#define	FIF_SDRConfigA		0x4C001000
#define	FIF_SDRConfigB		0x4C001004
#define	FIF_SDRPowerMng		0x4C001008
#define	FIF_SDRCmdCtrl		0x4C001100
#define	FIF_SDRModeReg		0x4C001110

#define	SMU_PLLSEL		0xC8010040
#define	SMU_PLLSEL2		0xC8010044
#define	SMU_CLK_DOMAIN_DIV	0xC8010048
#define	SMU_LPLL_CTR1		0xC8010050
#define	SMU_LPLL_CTR2		0xC8010054
#define	SMU_HPLL_CTR1		0xC8010058
#define	SMU_HPLL_CTR2		0xC801005C
#define	SMU_HPLL_CTR3		0xC8010060
#define	SMU_HPLL_CTR4		0xC8010064
#define	SMU_PLLLOCK_CTRL	0xC8010068

#define	SMU_SDR_CLK_DLY		0xC80101C4
#define	SMU_SDR_UDCLK_DLY	0xC80101C8
#define	SMU_SDR_LDCLK_DLY	0xC80101CC

#define	SMU_DRV_LCD		0xC8010250
#define	SMU_DRV_SDRAM		0xC8010254
#define	SMU_DRV_D1		0xC8010258
#define	SMU_DRV_D2		0xC801025C

//;;; --- for UART control

#define	SMU_U70_SCLK_SEL	0xC801010C
#define	SMU_U70_SCLK_DIV	0xC8010148
#define	SMU_AB1_U70WAITCTRL	0xC8010380

//;;; --- for Automatic Power Control

#define	SMU_AHBCLKCTRL0		0xC80100A0
#define	SMU_AHBCLKCTRL1		0xC80100A4
#define	SMU_APBCLKCTRL		0xC80100A8
#define	SMU_CLKCTRL		0xC80100AC

#define	PB0_BASE		0x40110000
#define	PB0_TI1PCLKCTRL		0x40110000
#define	PB0_DCVPCLKCTRL		0x4011000C
#define	PB0_FIFPCLKCTRL		0x4011001C
#define	PB0_ROTCLKCTRL		0x40110020
#define	PB0_DMAPCLKCTRL		0x40110024
#define	PB0_IMGPCLKCTRL		0x40110028
#define	PB0_CAMPCLKCTRL		0x40110030
#define	PB0_SP0PCLKCTRL		0x40110034
#define	PB0_SP1PCLKCTRL		0x40110038

#define	PB1_BASE		0xC0090000
#define	PB1_TI0PCLKCTRL		0xC0090000
#define	PB1_GIOCLKCTRL		0xC0090004
#define	PB1_INTPCLKCTRL		0xC0090008
#define	PB1_SMUPCLKCTRL		0xC009000C
#define	PB1_LCDPCLKCTRL		0xC0090010
#define	PB1_MWIPCLKCTRL		0xC0090018
#define	PB1_PMUPCLKCTRL		0xC0090024

//;;; --- for LCD control

#define	SMU_LCD_LCLK_SEL   	0xC8010100
#define	SMU_LCD_LCLK_DIV   	0xC8010130
#define	SMU_GCLKEN_POL    	0xC8010098

#define	LCD_BASE		0xC0040000
#define	LCD_CONTROL		0xC0040000

//;;; --- for clock control

#define	SMU_GCLKCTRL0		0xC8010080
#define	SMU_GCLKCTRL0ENA	0xC801008C
#define	SMU_GCLKCTRL1		0xC8010084
#define	SMU_GCLKCTRL1ENA	0xC8010090
#define	SMU_GCLKCTRL2		0xC8010088
#define	SMU_GCLKCTRL2ENA	0xC8010094

#define	SMU_S1_BASE		0xCC000000
#define	SMU_SWTTRACECLK		0xCC000000

//;;; --- for DSP-debugger <-> ARM core I/F

#define	SWT_PE0_INT_MASK_SET	0x80000040

//;;; --- Auto Frequency Change

#define SMU_AUTO_FREQ_CHANGE	0xC80100B0
#define SMU_PLL_DOWN_EN		0xC80100B4

//;;; --- select Terminal of using combinedly
#define SMU_PCTL_ASYNC		0xC8010200
#define SMU_PCTL_SDR		0xC8010204
#define SMU_PCTL_NAND		0xC8010208
#define SMU_PCTL_C1		0xC801020C
#define SMU_PCTL_DJTAG		0xC8010210
#define SMU_PCTL_CAM		0xC8010214
#define SMU_GIOCTL_PM1		0xC8010218
#define SMU_PCTL_SPI		0xC801021C
#define SMU_PCTL_C2		0xC8010220

/* 2006.08.22 has : add register address */
#ifdef CONFIG_ICX1087
#define SMU_PULLCTL_ASYNC		0xC8010224
#define SMU_PULLCTL_SDR			0xC8010228
#define SMU_PULLCTL_NAND		0xC801022C
#define SMU_PULLCTL_P1			0xC8010230
#define SMU_PULLCTL_CPUDEBUG	0xC8010234
#define SMU_PULLCTL_DSPDEBUG	0xC8010238
#define SMU_PULLCTL_CAM			0xC801023C
#define SMU_PULLCTL_PCM			0xC8010240
#define SMU_PULLCTL_SPI			0xC8010244
#define SMU_PULLCTL_P2			0xC8010248
#define SMU_PULLCTL_TST			0xC801024C
#else
#define SMU_PULLCTL_P1		0xC8010230
#endif
#define SMU_MSP_SCLK_DIV	0xC8010160

#define SMU_INT_CLEAR		0xC80101A4
#define SMU_INT_RAW_STATUS	0xC8010194

# define SMU_PULLCTL_SDR	0xC8010228

/* 2006.08.30 has : add gpo register address */
#ifdef CONFIG_ICX1087
//;;; --- GPO
# define SMU_GPO			0xC8010288
#endif

//;;; --- for GPIO initialize

#define GIO_BASE		0xC0050000
#define GIO0_OFFSET		0x00000000
#define GIO1_OFFSET		0x00000100
#define GIO2_OFFSET		0x00000200
#define GIO3_OFFSET		0x00000300

#define GIO_GP_EO		0x00000000
#define GIO_GP_EI		0x00000004
#define GIO_GP_IA		0x00000010
#define GIO_GP_IME		0x00000018
#define GIO_GP_IR		0x00000024

#define GIO_GP0_EO		(GIO0_OFFSET | GIO_GP_EO)
#define GIO_GP0_EI		(GIO0_OFFSET | GIO_GP_EI)
#define GIO_GP0_IA		(GIO0_OFFSET | GIO_GP_IA)
#define GIO_GP0_IME		(GIO0_OFFSET | GIO_GP_IME)
#define GIO_GP0_IR		(GIO0_OFFSET | GIO_GP_IR)

#define GIO_GP1_EO		(GIO1_OFFSET | GIO_GP_EO)
#define GIO_GP1_EI		(GIO1_OFFSET | GIO_GP_EI)
#define GIO_GP1_IA		(GIO1_OFFSET | GIO_GP_IA)
#define GIO_GP1_IME		(GIO1_OFFSET | GIO_GP_IME)
#define GIO_GP1_IR		(GIO1_OFFSET | GIO_GP_IR)

#define GIO_GP2_EO		(GIO2_OFFSET | GIO_GP_EO)
#define GIO_GP2_EI		(GIO2_OFFSET | GIO_GP_EI)
#define GIO_GP2_IA		(GIO2_OFFSET | GIO_GP_IA)
#define GIO_GP2_IME		(GIO2_OFFSET | GIO_GP_IME)
#define GIO_GP2_IR		(GIO2_OFFSET | GIO_GP_IR)

#define GIO_GP3_EO		(GIO3_OFFSET | GIO_GP_EO)
#define GIO_GP3_EI		(GIO3_OFFSET | GIO_GP_EI)
#define GIO_GP3_IA		(GIO3_OFFSET | GIO_GP_IA)
#define GIO_GP3_IME		(GIO3_OFFSET | GIO_GP_IME)
#define GIO_GP3_IR		(GIO3_OFFSET | GIO_GP_IR)


//;;; ---------------------------------------------------------------------
//;;; -------  Each values
//;;; ---------------------------------------------------------------------

//;;; --- reset control

/* 2006.08.22 has : modify reset value */
#ifdef CONFIG_ICX1087
#define	SMU_RESETREQ0_VAL		0x000000EA
#define	SMU_RESETREQ0_RSM_VAL	(0x000000EA|0x00000010)
#define	SMU_RESETREQ1A_VAL		(0x000287F9|0x00040000)
#define	SMU_RESETREQ1A_RSM_VAL	(0x000287F9|0x00040000)
#define	SMU_RESETREQ1B_VAL		0x00000004
#define	SMU_RESETREQ1B_RSM_VAL	(0x00000004|0x00004001)
#define	SMU_RESETREQDSP_VAL		(0x00000000|0x00000002)
#else
#define	SMU_RESETREQ0_VAL	0x000002FE	/* USB/GIO/PMU/INT/PWM/MWI/TW0/TI0 */
#define	SMU_RESETREQ0_RSM_VAL	0x000003FF	/* USB/TFD/GIO/PMU/INT/PWM/MWI/TW0/TI0/LCD */
#define	SMU_RESETREQ1A_VAL	0x0006C7F9	/* DCV/SDR/NAND/ATA/FIF/PB0-1/AB0-1/SWT/DMA/SRC/PE0 */
#define	SMU_RESETREQ1A_RSM_VAL	0x000647F9	/* DCV/SDR/ATA/FIF/PB0-1/AB0-1/SWT/DMA/SRC/PE0 */
#define	SMU_RESETREQ1B_VAL	0x0000EFFF	/* STM/MMM/MSP/PM0-1/TW1/TI1-5/I2C/U70/SPI0-1 */
#define	SMU_RESETREQ1B_RSM_VAL	0x0000EBFF	/* STM/MMM/MSP/PM1/TW1/TI1-5/I2C/U70/SPI0-1 */
#define	SMU_RESETREQDSP_VAL	0x00000002	/* DSP_HRSTZ */
#endif

#define	SMU_RESETREQ1AENA_AB1	0x00000080
#define	SMU_RESETREQ1BENA_U70	0x00000004

#define	SWT_PE0_INT_MASK_SET_VAL	0x00000001

//;;; ---------------------------------------------------------------------
//;;; AB0 wait ctrl

/* 2006.11.1 fuj */
#ifdef CONFIG_ICX1087
#define	SMU_AB0_CS0WAITCTL_VAL		AB0CS01WAIT
#define	SMU_AB0_CS0WAITCTL_W_VAL	AB0CS01WAIT_W
#define SMU_AB0_CS1WAITCTL_VAL		AB0CS01WAIT
#define SMU_AB0_CS1WAITCTL_W_VAL	AB0CS01WAIT_W
#define SMU_AB0_CS2WAITCTL_VAL		AB0CS01WAIT
#define SMU_AB0_CS2WAITCTL_W_VAL	AB0CS01WAIT_W
#define SMU_AB0_FLASHCLKCTRL_VAL	0x00000003
#else	/* CONFIG_ICX1087 */
/* #define AB0CS01WAIT			0x00010401 	(mp200mct.h) */
#define	SMU_AB0_CS0WAITCTL_VAL		AB0CS01WAIT
#define	SMU_AB0_CS0WAITCTL_W_VAL	(AB0CS01WAIT & ~0xff0000ff)
#ifndef CONFIG_MP200_MINI_BOARD
# define EBC_WRZ_WAIT_VAL		((AB0CS01WAIT & 0x0000ff00) >> 8)
#else	/* define CONFIG_MP200_MINI_BOARD */
# define SMU_AB0_CS1WAITCTL_VAL		AB0CS01WAIT
# define SMU_AB0_CS1WAITCTL_W_VAL	(AB0CS01WAIT & ~0xff0000ff)
#endif	/* define CONFIG_MP200_MINI_BOARD */
#endif	/* define CONFIG_ICX1087 */

#define	SMU_GCLKCTRLENA_VAL_CLR		0x00000000	/* all disable */
//;;; -- for GCLKCTRL0-2 (stop clock)

/* 2006.08.22 has : modify clock gating value */
#ifdef CONFIG_ICX1087
#define	SMU_GCLKCTRL0ENA_VAL		0xFFFFFFFF
#define	SMU_GCLKCTRL1ENA_VAL		0xFFFFFFFF
#define	SMU_GCLKCTRL2ENA_VAL		0xFFFFFFFF
#define	SMU_GCLKCTRL0_VAL			(0x07FFE060|0x00000001)
#define	SMU_GCLKCTRL1_VAL			(0x30318600|0x00001800)
#define SMU_GCLKCTRL2_VAL           (0x1D030C00|0x02006030)
#define	SMU_GCLKCTRL0ENA_RSM_VAL	SMU_GCLKCTRL0ENA_VAL
#define	SMU_GCLKCTRL0_RSM_VAL		SMU_GCLKCTRL0_VAL
#else
#define	SMU_GCLKCTRL0ENA_VAL		0x00000F06	/* TFD/LCD/IMG */
#define	SMU_GCLKCTRL1ENA_VAL		0x0000007F	/* DTV/NTSC/CAM */
#define	SMU_GCLKCTRL2ENA_VAL		0x00009603	/* REF/SDR/FLA/CPI/SDM */
#define	SMU_GCLKCTRL0_VAL		(~SMU_GCLKCTRL0ENA_VAL)
#define	SMU_GCLKCTRL1_VAL		(~SMU_GCLKCTRL1ENA_VAL)
#define	SMU_GCLKCTRL2_VAL		0x00008600	/* REF/SDR/FLA : ON */
#define	SMU_GCLKCTRL0ENA_RSM_VAL	0x00000000	/* none */
#define	SMU_GCLKCTRL0_RSM_VAL		(~SMU_GCLKCTRL0ENA_RSM_VAL)
#endif

#define	SMU_SWTTRACECLK_MASK		0x00000001
#define	SMU_SWTTRACECLK_VAL		(~SMU_SWTTRACECLK_MASK)


//;;; PLL frequency	HPLL = (OSC * n) / (m * p)

#define	SMU_PLLSEL_VAL		0x00000002	/* PLL use */
#define	SMU_PLLSEL2_VAL		0x00000001	/* HPLL use */
#if defined(PLL_192MHZ) || defined(PLL_48MHZ)	/* 192MHz or 48MHz */
#  define SMU_HPLL_CTR1_VAL	0x0000000F	/* n=16 */
#  define SMU_HPLL_CTR2_VAL	0x00000000	/* m=1 */
#else	/* PLL_248MHZ or PLL_124MHZ */
# ifdef MP201EL_BD	/* OSC = 12MHz */
#  define SMU_HPLL_CTR1_VAL	0x0000003D	/* n=62 */
#  define SMU_HPLL_CTR2_VAL	0x00000002	/* m=3 */
# else			/* OSC = 11.2896MHz */
#  define SMU_HPLL_CTR1_VAL	0x00000015	/* n=22 */
#  define SMU_HPLL_CTR2_VAL	0x00000000	/* m=1 */
# endif
# endif
#ifdef	PLL_48MHZ	/* 48MHz */
#  define SMU_HPLL_CTR3_VAL	0x00000001	/* p=2 */
#else	/* 124 or 192 or 248 MHz */
#  define SMU_HPLL_CTR3_VAL	0x00000000	/* p=1 */
# endif
#define	SMU_HPLL_CTR4_VAL	0x00000001	/* HPLL enable */
#define	SMU_PLLLOCK_CTRL_VAL	0x00000000	/* lockup enable */

/* 2006.08.03 fuj : apply power-saving */
#ifdef CONFIG_ICX1087
#define	SMU_LPLL_CTR1_VAL	0x00000000
#define	SMU_LPLL_CTR2_VAL	0x00000000	/* LPLL disable */
#else
#define	SMU_LPLL_CTR1_VAL	0x0000000A	/* LPLL 163.840MHz */
#define	SMU_LPLL_CTR2_VAL	0x00000001	/* LPLL enable */
#endif /* CONFIG_ICX1087 */

#define SMU_INT_CLEAR_VAL	0x00000001	/* clock change interrupt clear */
#define	SMU_INT_RAW_STATUS_VAL	0x00000001


//;;; --- for LCD setting

/* 2006.04.25 fuj : Modified LCD clock */
#ifdef CONFIG_ICX1087
/* 2006.05.11 fuj : For CPU clock 250MHz */
#define	SMU_LCD_LCLK_SEL_VAL	0x00000002	//; use HPLL(248MHz)
#define	SMU_LCD_LCLK_DIV_VAL	0x00000130	//; LCD_LCLK 5MHz 
#else
#define	SMU_LCD_LCLK_SEL_VAL	0x00000000	//; use OSC(12MHz)
#define	SMU_LCD_LCLK_DIV_VAL	0x00000101	//; LCD_LCLK 6MHz 
#endif /* CONFIG_ICX1087 */
#define	LCD_CONTROL_VAL		0x00000146

#ifdef CONFIG_MP201_ES10
# define SMU_GCLKEN_POL_VAL 0x00000031  //; default (CPU:SDRAM = 1:1)
#else
# ifndef	PLL_48MHZ	/* 124/192/248MHz */
# define SMU_GCLKEN_POL_VAL	0x00000012	/* if CPU:SDRAM = 2:1 */
# else
# define SMU_GCLKEN_POL_VAL	0x00000031	//; default (CPU:SDRAM = 1:1)
# endif
#endif

//;;; -- for SDR/FIFO setting
# define SMU_SDR_CLK_DLY_VAL	0x0000003F
#define SMU_SDR_UDCLK_DLY_VAL	0x00000000
#define SMU_SDR_LDCLK_DLY_VAL	0x00000000

#ifndef	PLL_48MHZ	/* 124/192/248MHz */
# define SMU_PULLCTL_SDR_VAL	0x00000000
#endif
#define SMU_DRV_SDRAM_VAL	0x00000055	/* all 6mA */


//;;; --- for SDR setting

#ifdef	PLL_48MHZ
# define FIF_SDRModeReg_VAL	0x00200000	/* not write */
#else	/* 124/192/248MHz */
# define FIF_SDRModeReg_VAL		0x00400033
#endif
#ifdef CONFIG_MP201_ES10
# define FIF_SDRConfigB_VAL     0x00044002  /* read cycle 2clock */
#else
# if defined(PLL_124MHZ) || defined(PLL_48MHZ)	/* 124MHz or 48MHz */
# define FIF_SDRConfigB_VAL		0x00024002	/* read cycle 1.5clock */
# else						/* 192MHz or 248MHz */
# define FIF_SDRConfigB_VAL		0x00044002	/* read cycle 2clock */
# endif
#endif
#define FIF_SDRConfigA_VAL      0x83233119
#define	FIF_SDRPowerMng_VAL	0x002E11FF
#define	FIF_SDRCmdCtrl_VAL_1	0x0000011B
#define	FIF_SDRCmdCtrl_VAL_2	0x00000115
#define	FIF_SDRCmdCtrl_RSM_VAL_1	0x0000011A
#define	FIF_SDRCmdCtrl_RSM_VAL_2	0x00000115

//;;; --- for UART settings

#define	SMU_U70_SCLK_DIV_VAL	0x00000000
#define	SMU_U70_SCLK_SEL_VAL	0x00000000	/* OSC */
#define	SMU_AB1_U70WAITCTRL_VAL	0x00000431	/* Abn_CLK=62.5MHz recommend */

//;;; --- for Automatic Clock Control

/* 2006.08.22 has : modify auto clock control value */
#ifdef CONFIG_ICX1087
#define SMU_AHBCLKCTRL0_VAL     (0x000008E1|0x00002002)
#define SMU_AHBCLKCTRL1_VAL     (0x0000007F|0x00000100)
#define SMU_APBCLKCTRL_VAL      (0x000D23F0|0x00300000)
#define SMU_CLKCTRL_VAL         0x00000001
#else
#define SMU_AHBCLKCTRL0_VAL 0x00003FFF  /* ALL-Device */
#define SMU_AHBCLKCTRL1_VAL 0x0000017F  /* ALL-Device (SRCLP=OFF:ES1.1) */
//#define SMU_AHBCLKCTRL1_VAL   0x000001FF  /* ALL-Device */
#define SMU_APBCLKCTRL_VAL  0x001FFFFF  /* ALL-Device */
#define SMU_CLKCTRL_VAL     0x00000007  /* ALL-Device */
#endif

#define	AB0_BASE		0x2FFF0000
#define	AB0_FLASHCOMSET		0x2FFF0000

#ifndef CONFIG_MP200_MINI_BOARD
#define	AB0_FLASHCOMSET_VAL	0x00000003	/* CS0/CS1 */
#else
/* 2006.10.30 fuj : EPSON_USB */
#ifdef CONFIG_ICX1087
#define	AB0_FLASHCOMSET_VAL	0x00000047	/* CS0/CS1/CS2 */
#else
#define	AB0_FLASHCOMSET_VAL	0x00000001	/* CS0 */
#endif
#endif

#ifndef CONFIG_MP200_MINI_BOARD
/*
 * On Board Devices
 */
# define EBC_BASE		0x203E0000
# define EBC_LAN_RST		0x203E005C

# define EBC_DEF_BASE		0x2FFE0000
# define EBC_WRZ_WAIT		0x2FFE0070

# define EBC_LAN_RST_VAL	1
#endif	/* not define CONFIG_MP200_MINI_BOARD */

/*
 * Auto Frequency Change
 */
/* 2006.08.22 has : modify auto freq value */
#ifdef CONFIG_ICX1087
#ifdef PLL_48MHZ	/* 48MHz */
# define SMU_AUTO_FREQ_CHANGE_VAL	0x010110D0	/* NMRDIV:PLL/2,DOWNDIV:PLL/4 */
#else
# ifdef PLL_124MHZ	/* 124MHz */
#  define SMU_AUTO_FREQ_CHANGE_VAL	0x010310D0	/* NMRDIV:PLL/2,DOWNDIV:PLL/8 */
# else						/* 192MHz or 248MHz */
#  define SMU_AUTO_FREQ_CHANGE_VAL	0x000910D0	/* NMRDIV:PLL/1,DOWNDIV:PLL/8 */
# endif
#endif
#else
#ifdef PLL_48MHZ	/* 48MHz */
# define SMU_AUTO_FREQ_CHANGE_VAL	0x010100D0	/* NMRDIV:PLL/2,DOWNDIV:PLL/4 */
#else
# ifdef PLL_124MHZ	/* 124MHz */
#  define SMU_AUTO_FREQ_CHANGE_VAL	0x010300D0	/* NMRDIV:PLL/2,DOWNDIV:PLL/8 */
# else						/* 192MHz or 248MHz */
#  define SMU_AUTO_FREQ_CHANGE_VAL	0x000700D0	/* NMRDIV:PLL/1,DOWNDIV:PLL/8 */
# endif
#endif
#endif
#define SMU_PLL_DOWN_EN_VAL		0x00000001	/* PLL_DOWN_EN:ON */

//;;; --- select Terminal of using combinedly

/* 2006.08.22 has : modify pin control value */
#ifdef CONFIG_ICX1087
/* 2006.10.26 fuj : Not set FLASH CLOCK in U-Boot */
#define SMU_PCTL_ASYNC_VAL	0x0000001C
#define SMU_PCTL_SDR_VAL	0x00000001
#define SMU_PCTL_NAND_VAL	0x000000F8
#define SMU_PCTL_C1_VAL		0x0000000D
#define SMU_PCTL_DJTAG_VAL	0x00000001
#define SMU_PCTL_CAM_VAL	0x00000007
#define SMU_GIOCTL_PM1_VAL	0x00000001
#define SMU_PCTL_SPI_VAL	0x00000001
#define SMU_PCTL_C2_VAL		0x000000FC
#else
#define SMU_PCTL_ASYNC_VAL	0x00000000	/* AB0_CSZ2/AB0_CSZ3 */
#define SMU_PCTL_SDR_VAL	0x00000001	/* SDR 16bit + GPIO */
#define SMU_PCTL_NAND_VAL	0x00000080	/* NAND */
#define SMU_PCTL_C1_VAL		0x00000005	/* MS/UART */
#define SMU_PCTL_DJTAG_VAL	0x00000000	/* JTAG */
#define SMU_PCTL_CAM_VAL	0x00000002	/* GPIO_P17 */
#define SMU_GIOCTL_PM1_VAL	0x00000000	/* default */

#ifdef	COMB_SEL_CPI
#define SMU_PCTL_SPI_VAL	0x00000001	/* GPIO_P12 */
#else	/* use SPI */
#define SMU_PCTL_SPI_VAL	0x00000000	/* SPI */
#endif	/* COMB_SEL_CPI */

#ifdef	COMB_SEL_PMW0
#define SMU_PCTL_C2_B6		0x00000000
#else
#define SMU_PCTL_C2_B6		0x00000040	/* use GPIO_P8 */
#endif	/* COMB_SEL_PMW0 */

#ifdef	COMB_SEL_PMW1
#define SMU_PCTL_C2_B7		0x00000000
#else
#define SMU_PCTL_C2_B7		0x00000080	/* use GPIO_P7 */
#endif	/* COMB_SEL_PMW1 */

#define SMU_PCTL_C2_VAL		(0x0000002D|SMU_PCTL_C2_B6|SMU_PCTL_C2_B7)	/* MWI/IIC/GPIO_P2/3/6/USB */
#endif

/* 2006.08.22 has : modify pull control value */
#ifdef CONFIG_ICX1087
#define SMU_PULLCTL_ASYNC_VAL		0x0100008D
#define SMU_PULLCTL_NAND_VAL		0x000000FF
#define SMU_PULLCTL_P1_VAL			0x00001000
#define SMU_PULLCTL_CPUDEBUG_VAL	0x000C0003
#define SMU_PULLCTL_DSPDEBUG_VAL	0x0000000F
#define SMU_PULLCTL_CAM_VAL			0x000007FF
#define SMU_PULLCTL_PCM_VAL			0x00000007
#define SMU_PULLCTL_SPI_VAL			0x00000F01
#define SMU_PULLCTL_P2_VAL			0x000021FE
#define SMU_PULLCTL_TST_VAL			0x00000000
#else
#define SMU_PULLCTL_P1_VAL	0x0000100E	/* SMU_PULLCTL_P1_MS */
#endif

/* 2006.08.30 has : add gpo register address */
#ifdef CONFIG_ICX1087
//;;; --- GPO
# define SMU_GPO_VAL				0x00100010
#endif

#ifdef CONFIG_MP201_ES10
# define SMU_CLK_DOMAIN_DIV_VAL 0x00000003  /* HPLL/LPLL:FLASH_Domain=4:1, HPLL/LPLL:CPU_Domain=2:1 */
#else
# define SMU_CLK_DOMAIN_DIV_VAL	0x00000002	/* HPLL/LPLL:FLASH_Domain=4:1, HPLL/LPLL:CPU_Domain=1:1 */
#endif

#ifndef CONFIG_MP200_MINI_BOARD
# define GIO_GP0_EO_VAL		0x00000002
# define GIO_GP1_EO_VAL		0x00000002
#else	/* MINI_BOARD */
# define GIO_GP0_EO_VAL		0x00000180
# define GIO_GP1_EO_VAL		0x00000000
#endif	/* MINI_BOARD */
#define GIO_GP2_EO_VAL		0x00000020
#define GIO_GP3_EO_VAL		0x00000000

#define SRAM_WARM_UB_ADDR   0xA003F000
#define SRAM_WARM_PM_ADDR   0xA003F800


BEGIN_INIT_FUNC (platformsetup)
	.set	REG_PID, 0x80000000
	.set	ICACHE_LINE_SIZE_ORD, 5

.Lreset_pe0:
	// --- stop NMI to dsp
	SET_BASEREG(r0, REG_PID)
	mov	r1, #(SWT_PE0_INT_MASK_SET_VAL)
	str	r1, [r0, #(SWT_PE0_INT_MASK_SET & 0xfff)]

	// Enable ICache to prevent fetches under delay-control operations
	mrc	p15, 0, r0, c1, c0, 0
	orr	r0, r0, #0x1000
	mcr	p15, 0, r0, c1, c0, 0

	SET_BASEREG(r0, SMU_BASE)
	
	// --- relase reset
        MVN     r1, #0x00000000		/* all enable */
        STR     r1, [r0, #(SMU_RESETREQ0ENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1AENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1BENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQDSPENA & 0x00ff)]

	STORE_WORD(r0, SMU_RESETREQ0, SMU_RESETREQ0_VAL, r1)
	STORE_WORD(r0, SMU_RESETREQ1A, SMU_RESETREQ1A_VAL, r1)
	STORE_WORD(r0, SMU_RESETREQ1B, SMU_RESETREQ1B_VAL, r1)
	STORE_WORD(r0, SMU_RESETREQDSP, SMU_RESETREQDSP_VAL, r1)

        MOV     r1, #0x00000000		/* all disable */
        STR     r1, [r0, #(SMU_RESETREQ0ENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1AENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1BENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQDSPENA & 0x00ff)]

	// --- async bridge setting
	STORE_WORD(r0, SMU_AB0_CS0BASEADD, SMU_AB0_CS0BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS0BITCOMP, SMU_AB0_CS0BITCOMP_VAL, r1)

#ifndef	CONFIG_MP200_MINI_BOARD
	STORE_WORD(r0, SMU_AB0_CS1BASEADD, SMU_AB0_CS1BASEADD_VAL_DEF, r1)
	STORE_WORD(r0, SMU_AB0_CS1BITCOMP, SMU_AB0_CS1BITCOMP_VAL, r1)

	STORE_WORD(r0, SMU_AB0_CS2BASEADD, SMU_AB0_CS2BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS2BITCOMP, SMU_AB0_CS2BITCOMP_VAL, r1)

	STORE_WORD(r0, SMU_AB0_CS3BASEADD, SMU_AB0_CS3BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS3BITCOMP, SMU_AB0_CS3BITCOMP_VAL, r1)

	SET_BASEREG(r2, EBC_DEF_BASE)

	SET_BASEREG(r3, EBC_WRZ_WAIT_VAL)
	SET_BASEREG(r4, SMU_AB0_CS0WAITCTL_VAL)
	mov	r6, #32

	b	1f
	
	.align	ICACHE_LINE_SIZE_ORD
1:
	str	r3, [r2, #(EBC_WRZ_WAIT & 0xfff)]
2:
	subs	r6, r6, #1
	bgt	2b
	str	r4, [r0, #(SMU_AB0_CS0WAITCTL & 0xfff)]

	STORE_WORD(r0, SMU_AB0_CS0WAITCTL_W, SMU_AB0_CS0WAITCTL_W_VAL, r1)

	SET_BASEREG(r2, AB0_BASE)
	STORE_WORD(r2, AB0_FLASHCOMSET, AB0_FLASHCOMSET_VAL, r1)

	// -- modify CS1BASEADD to simplify address transration rule on linux kernel
	STORE_WORD(r0, SMU_AB0_CS1BASEADD, SMU_AB0_CS1BASEADD_VAL, r1)
#else	/* define CONFIG_MP200_MINI_BOARD */
	STORE_WORD(r0, SMU_AB0_CS1BASEADD, SMU_AB0_CS1BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS1BITCOMP, SMU_AB0_CS1BITCOMP_VAL, r1)
/* 2006.10.17 fuj : EPSON_USB */
#ifdef CONFIG_ICX1087
	STORE_WORD(r0, SMU_AB0_CS2BASEADD, SMU_AB0_CS2BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS2BITCOMP, SMU_AB0_CS2BITCOMP_VAL, r1)
#endif

	SET_BASEREG(r4, SMU_AB0_CS0WAITCTL_VAL)
	SET_BASEREG(r5, SMU_AB0_CS1WAITCTL_VAL)
/* 2006.10.18 fuj */
#ifdef CONFIG_ICX1087
	SET_BASEREG(r3, SMU_AB0_CS2WAITCTL_VAL)
#endif
	mov	r6, #32

	b	2f
	.align	ICACHE_LINE_SIZE_ORD
2:
	subs	r6, r6, #1
	bgt	2b
	str	r4, [r0, #(SMU_AB0_CS0WAITCTL & 0xfff)]
	str	r5, [r0, #(SMU_AB0_CS1WAITCTL & 0xfff)]
/* 2006.10.18 fuj */
#ifdef CONFIG_ICX1087
	str	r3, [r0, #(SMU_AB0_CS2WAITCTL & 0xfff)]
#endif

	STORE_WORD(r0, SMU_AB0_CS0WAITCTL_W, SMU_AB0_CS0WAITCTL_W_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS1WAITCTL_W, SMU_AB0_CS1WAITCTL_W_VAL, r1)
/* 2006.10.18 fuj */
#ifdef CONFIG_ICX1087
	STORE_WORD(r0, SMU_AB0_CS2WAITCTL_W, SMU_AB0_CS2WAITCTL_W_VAL, r1)

/* 2006.10.31 has : Set FLASH CLOCK in U-Boot */
#if 1
	STORE_WORD(r0, SMU_AB0_FLASHCLKCTRL, SMU_AB0_FLASHCLKCTRL_VAL, r1)
#endif
#endif

	SET_BASEREG(r2, AB0_BASE)
	STORE_WORD(r2, AB0_FLASHCOMSET, AB0_FLASHCOMSET_VAL, r1)
#endif	/* define CONFIG_MP200_MINI_BOARD */
	
	/* Disable unused clock lines */
	SET_BASEREG(r3, SMU_S1_BASE)
	STORE_WORD(r3, SMU_SWTTRACECLK, SMU_SWTTRACECLK_VAL, r1)

	STORE_WORD(r0, SMU_GCLKCTRL0ENA, SMU_GCLKCTRL0ENA_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL0, SMU_GCLKCTRL0_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL0ENA, SMU_GCLKCTRLENA_VAL_CLR, r1)

	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRL1ENA_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1, SMU_GCLKCTRL1_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRLENA_VAL_CLR, r1)

	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2, SMU_GCLKCTRL2_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRLENA_VAL_CLR, r1)

/* 2006.06.09 fuj : For NAND boot */
#if defined(CONFIG_ICX1087) && defined(CONFIG_NANDBOOT)
/* 2006.08.03 fuj : apply power-saving */
	/* LPLL disable */
	STORE_WORD(r0, SMU_LPLL_CTR1, SMU_LPLL_CTR1_VAL, r1)
	STORE_WORD(r0, SMU_LPLL_CTR2, SMU_LPLL_CTR2_VAL, r1)
#else
	
	/* set DOMAIN_DIV */
	STORE_WORD(r0, SMU_CLK_DOMAIN_DIV, SMU_CLK_DOMAIN_DIV_VAL, r1)
	STORE_WORD(r0, SMU_PCTL_SDR, SMU_PCTL_SDR_VAL, r1)

	// --- set SDRAM timigs
	STORE_WORD(r0, SMU_SDR_CLK_DLY, SMU_SDR_CLK_DLY_VAL, r1)
	STORE_WORD(r0, SMU_SDR_UDCLK_DLY, SMU_SDR_UDCLK_DLY_VAL, r1)
	STORE_WORD(r0, SMU_SDR_LDCLK_DLY, SMU_SDR_LDCLK_DLY_VAL, r1)
#ifdef	PLL_48MHZ
#else
	STORE_WORD(r0, SMU_PULLCTL_SDR, SMU_PULLCTL_SDR_VAL, r1)
#endif

	STORE_WORD(r0, SMU_DRV_SDRAM, SMU_DRV_SDRAM_VAL, r1)

	SET_BASEREG	(r0, FIF_SDR_BASE)
#if 1	// no needs for elpida SDR
	STORE_WORD(r0, FIF_SDRConfigB, FIF_SDRConfigB_VAL, r1)
#endif
	STORE_WORD(r0, FIF_SDRConfigA, FIF_SDRConfigA_VAL, r1)
	STORE_WORD(r0, FIF_SDRPowerMng, FIF_SDRPowerMng_VAL, r1)
	STORE_WORD(r0, FIF_SDRModeReg, FIF_SDRModeReg_VAL, r1)
	STORE_WORD(r0, FIF_SDRCmdCtrl, FIF_SDRCmdCtrl_VAL_1, r1)

	// --- wait for SDR
	MOV		r1, #0x00000000
SDRINITWAIT:
	ADD		r1, r1, #1
	CMP		r1, #4096
	NOP
	BNE		SDRINITWAIT

	STORE_WORD(r0, FIF_SDRCmdCtrl, FIF_SDRCmdCtrl_VAL_2, r1)

	SET_BASEREG(r0, SMU_BASE)

	// --- start PLL
	MOV	r7,	#(SMU_INT_RAW_STATUS_VAL)

	STORE_WORD(r0, SMU_GCLKEN_POL, SMU_GCLKEN_POL_VAL, r1)

	STORE_WORD(r0, SMU_PLLLOCK_CTRL, SMU_PLLLOCK_CTRL_VAL, r1)
	STORE_WORD(r0, SMU_LPLL_CTR1, SMU_LPLL_CTR1_VAL, r1)
	/* LPLL enable */
	STORE_WORD(r0, SMU_LPLL_CTR2, SMU_LPLL_CTR2_VAL, r1)
	STORE_WORD(r0, SMU_HPLL_CTR1, SMU_HPLL_CTR1_VAL, r1)
	STORE_WORD(r0, SMU_HPLL_CTR2, SMU_HPLL_CTR2_VAL, r1)
	STORE_WORD(r0, SMU_HPLL_CTR3, SMU_HPLL_CTR3_VAL, r1)
	/* choice HPLL */
	STORE_WORD(r0, SMU_PLLSEL2, SMU_PLLSEL2_VAL, r1)
	/* HPLL enable */
	STORE_WORD(r0, SMU_HPLL_CTR4, SMU_HPLL_CTR4_VAL, r1)
	/* clear Interrupt */
	STORE_WORD(r0, SMU_INT_CLEAR, SMU_INT_CLEAR_VAL, r1)
	/* select PLL */
	SET_BASEREG(r1, SMU_PLLSEL_VAL)
	LDR	r6, [r0, #(SMU_PLLSEL & 0xfff)]
	CMP	r6, r1
	NOP
	BEQ	CLK_PLL
	nop
	nop
	nop
	nop

	b	1f
	
	// --- Wait for PLL

	.align	ICACHE_LINE_SIZE_ORD
1:
	STR	r1, [r0, #(SMU_PLLSEL & 0xfff)]

CLK192_WAIT:
	LDR	r6, [r0, #(SMU_INT_RAW_STATUS & 0xfff)]
	CMP	r6, r7
	NOP
	BNE	CLK192_WAIT

#endif  /* CONFIG_ICX1087 && CONFIG_NANDBOOT */

CLK_PLL:
	STORE_WORD(r0, SMU_LCD_LCLK_SEL, SMU_LCD_LCLK_SEL_VAL, r1)
	STORE_WORD(r0, SMU_LCD_LCLK_DIV, SMU_LCD_LCLK_DIV_VAL, r1)
//	STORE_WORD(r0, SMU_GCLKEN_POL, SMU_GCLKEN_POL_VAL, r1)

	SET_BASEREG(r0, LCD_BASE)
	STORE_WORD(r0, LCD_CONTROL, LCD_CONTROL_VAL, r1)

	//;; select Terminal of using combinedly

	SET_BASEREG(r0, SMU_BASE)

/* 2006.05.22 fuj */
#ifdef CONFIG_ICX1087
    STORE_WORD(r0, SMU_PCTL_ASYNC, SMU_PCTL_ASYNC_VAL, r1)
//  STORE_WORD(r0, SMU_PCTL_SDR, SMU_PCTL_SDR_VAL, r1)
    STORE_WORD(r0, SMU_PCTL_NAND, SMU_PCTL_NAND_VAL, r1)
    STORE_WORD(r0, SMU_PCTL_C1, SMU_PCTL_C1_VAL, r1)
    STORE_WORD(r0, SMU_PCTL_DJTAG, SMU_PCTL_DJTAG_VAL, r1)
    STORE_WORD(r0, SMU_PCTL_CAM, SMU_PCTL_CAM_VAL, r1)
    STORE_WORD(r0, SMU_GIOCTL_PM1, SMU_GIOCTL_PM1_VAL, r1)
    STORE_WORD(r0, SMU_PCTL_SPI, SMU_PCTL_SPI_VAL, r1)
    STORE_WORD(r0, SMU_PCTL_C2, SMU_PCTL_C2_VAL, r1)

    STORE_WORD(r0, SMU_PULLCTL_ASYNC, SMU_PULLCTL_ASYNC_VAL, r1)
//  STORE_WORD(r0, SMU_PULLCTL_SDR, SMU_PULLCTL_SDR_VAL, r1)
    STORE_WORD(r0, SMU_PULLCTL_NAND, SMU_PULLCTL_NAND_VAL, r1)
    STORE_WORD(r0, SMU_PULLCTL_P1, SMU_PULLCTL_P1_VAL, r1)
    STORE_WORD(r0, SMU_PULLCTL_CPUDEBUG, SMU_PULLCTL_CPUDEBUG_VAL, r1)
    STORE_WORD(r0, SMU_PULLCTL_DSPDEBUG, SMU_PULLCTL_DSPDEBUG_VAL, r1)
    STORE_WORD(r0, SMU_PULLCTL_CAM, SMU_PULLCTL_CAM_VAL, r1)
    STORE_WORD(r0, SMU_PULLCTL_PCM, SMU_PULLCTL_PCM_VAL, r1)
    STORE_WORD(r0, SMU_PULLCTL_SPI, SMU_PULLCTL_SPI_VAL, r1)
    STORE_WORD(r0, SMU_PULLCTL_P2, SMU_PULLCTL_P2_VAL, r1)
    STORE_WORD(r0, SMU_PULLCTL_TST, SMU_PULLCTL_TST_VAL, r1)
#else
	STORE_WORD(r0, SMU_PCTL_ASYNC, SMU_PCTL_ASYNC_VAL, r1)
//	STORE_WORD(r0, SMU_PCTL_SDR, SMU_PCTL_SDR_VAL, r1)
	STORE_WORD(r0, SMU_PCTL_NAND, SMU_PCTL_NAND_VAL, r1)
	STORE_WORD(r0, SMU_PCTL_C1, SMU_PCTL_C1_VAL, r1)
	STORE_WORD(r0, SMU_PCTL_DJTAG, SMU_PCTL_DJTAG_VAL, r1)
	STORE_WORD(r0, SMU_PCTL_CAM, SMU_PCTL_CAM_VAL, r1)
	STORE_WORD(r0, SMU_GIOCTL_PM1, SMU_GIOCTL_PM1_VAL, r1)
	STORE_WORD(r0, SMU_PCTL_SPI, SMU_PCTL_SPI_VAL, r1)
	STORE_WORD(r0, SMU_PCTL_C2, SMU_PCTL_C2_VAL, r1)
	STORE_WORD(r0, SMU_PULLCTL_P1, SMU_PULLCTL_P1_VAL, r1)
#endif /* CONFIG_ICX1087 */

/* 2006.08.30 has */
#ifdef CONFIG_ICX1087
	// --- Set GPO4 to High for USB_PWRCL
	STORE_WORD(r0, SMU_GPO, SMU_GPO_VAL, r1)
#endif

	//;; for UART console

	STORE_WORD(r0, SMU_RESETREQ1AENA, SMU_RESETREQ1AENA_AB1, r1)
	STORE_WORD(r0, SMU_RESETREQ1A, SMU_RESETREQ1A_VAL, r1)

	STORE_WORD(r0, SMU_U70_SCLK_DIV, SMU_U70_SCLK_DIV_VAL, r1)
	STORE_WORD(r0, SMU_U70_SCLK_SEL, SMU_U70_SCLK_SEL_VAL, r1)

	STORE_WORD(r0, SMU_AB1_U70WAITCTRL, SMU_AB1_U70WAITCTRL_VAL, r1)

	STORE_WORD(r0, SMU_RESETREQ1BENA, SMU_RESETREQ1BENA_U70, r1)
	STORE_WORD(r0, SMU_RESETREQ1B, SMU_RESETREQ1B_VAL, r1)

        MOV     r1, #0x00000000		/* all disable */
        STR     r1, [r0, #(SMU_RESETREQ1AENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1BENA & 0x00ff)]

#ifdef	PROV_BOOT
#else	/* normal boot */
	/* Enable Automatic Clock Control */
	SET_BASEREG(r0, SMU_BASE)
	STORE_WORD(r0, SMU_APBCLKCTRL, SMU_APBCLKCTRL_VAL, r1)
	STORE_WORD(r0, SMU_AHBCLKCTRL0, SMU_AHBCLKCTRL0_VAL, r1)
	STORE_WORD(r0, SMU_AHBCLKCTRL1, SMU_AHBCLKCTRL1_VAL, r1)
	STORE_WORD(r0, SMU_CLKCTRL, SMU_CLKCTRL_VAL, r1)

	/* Auto Frequency Change */
	STORE_WORD(r0, SMU_AUTO_FREQ_CHANGE, SMU_AUTO_FREQ_CHANGE_VAL, r1)
	STORE_WORD(r0, SMU_PLL_DOWN_EN, SMU_PLL_DOWN_EN_VAL, r1)
#endif

	/* Initialize On Board Devices */
	
/* 2006.05.22 fuj */
#ifndef CONFIG_ICX1087
	/* initialize gpio */
	SET_BASEREG(r0, GIO_BASE)
	
        MOV     r1, #0x00000000		/* all disable */
        STR     r1, [r0, #(GIO_GP0_IA & 0x0fff)]
        STR     r1, [r0, #(GIO_GP1_IA & 0x0fff)]
        STR     r1, [r0, #(GIO_GP2_IA & 0x0fff)]
        STR     r1, [r0, #(GIO_GP3_IA & 0x0fff)]
	
        MVN     r1, #0x00000000		/* all enable */
        STR     r1, [r0, #(GIO_GP0_IME & 0x0fff)]
        STR     r1, [r0, #(GIO_GP1_IME & 0x0fff)]
        STR     r1, [r0, #(GIO_GP2_IME & 0x0fff)]
        STR     r1, [r0, #(GIO_GP3_IME & 0x0fff)]

        STR     r1, [r0, #(GIO_GP0_IR & 0x0fff)]
        STR     r1, [r0, #(GIO_GP1_IR & 0x0fff)]
        STR     r1, [r0, #(GIO_GP2_IR & 0x0fff)]
        STR     r1, [r0, #(GIO_GP3_IR & 0x0fff)]

        /* all input port */
        STR     r1, [r0, #(GIO_GP0_EI & 0x0fff)]
        STR     r1, [r0, #(GIO_GP1_EI & 0x0fff)]
        STR     r1, [r0, #(GIO_GP2_EI & 0x0fff)]
        STR     r1, [r0, #(GIO_GP3_EI & 0x0fff)]

	/* set output port */
	STORE_WORD(r0, GIO_GP0_EO, GIO_GP0_EO_VAL, r1)
	STORE_WORD(r0, GIO_GP1_EO, GIO_GP1_EO_VAL, r1)
	STORE_WORD(r0, GIO_GP2_EO, GIO_GP2_EO_VAL, r1)
	STORE_WORD(r0, GIO_GP3_EO, GIO_GP3_EO_VAL, r1)
#endif /* CONFIG_ICX1087 */
	
#ifndef CONFIG_MP200_MINI_BOARD
	/* release Ethernet controller RESET */
	SET_BASEREG(r0, EBC_BASE)
	STORE_WORD(r0, EBC_LAN_RST, EBC_LAN_RST_VAL, r1)
#endif	/* not define CONFIG_MP200_MINI_BOARD */

	// Disable ICache to avoid cache aliases
	mov	r1, #0x1000
	mvn	r1, r1
	mrc	p15, 0, r0, c1, c0, 0
	and	r0, r0, r1
	mcr	p15, 0, r0, c1, c0, 0

//// -------------------------------------------------------------------------
5:	
	mov	pc, lr

END_INIT_FUNC (platformsetup)

//// -------------------------------------------------------------------------
//// -------------------------------------------------------------------------
//// -------------------------------------------------------------------------

BEGIN_INIT_FUNC (boot_pll_to_warmboot)
	// Enable ICache to prevent fetches under delay-control operations
	mrc	p15, 0, r0, c1, c0, 0
	orr	r0, r0, #0x1000
	mcr	p15, 0, r0, c1, c0, 0

	// --- stop NMI to dsp
	SET_BASEREG(r0, REG_PID)
	mov	r1, #(SWT_PE0_INT_MASK_SET_VAL)
	str	r1, [r0, #(SWT_PE0_INT_MASK_SET & 0xfff)]

	SET_BASEREG(r0, SMU_BASE)
	
	// --- relase reset
        MVN     r1, #0x00000000		/* all enable */
	STR     r1, [r0, #(SMU_RESETREQ0ENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1AENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1BENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQDSPENA & 0x00ff)]

	STORE_WORD(r0, SMU_RESETREQ0, SMU_RESETREQ0_RSM_VAL, r1)
	STORE_WORD(r0, SMU_RESETREQ1A, SMU_RESETREQ1A_RSM_VAL, r1)
	STORE_WORD(r0, SMU_RESETREQ1B, SMU_RESETREQ1B_RSM_VAL, r1)
	STORE_WORD(r0, SMU_RESETREQDSP, SMU_RESETREQDSP_VAL, r1)

        MOV     r1, #0x00000000		/* all disable */
        STR     r1, [r0, #(SMU_RESETREQ0ENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1AENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1BENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQDSPENA & 0x00ff)]
	
	/* Disable unused clock lines */
	SET_BASEREG(r3, SMU_S1_BASE)
	STORE_WORD(r3, SMU_SWTTRACECLK, SMU_SWTTRACECLK_VAL, r1)

	STORE_WORD(r0, SMU_GCLKCTRL0ENA, SMU_GCLKCTRL0ENA_RSM_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL0, SMU_GCLKCTRL0_RSM_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL0ENA, SMU_GCLKCTRLENA_VAL_CLR, r1)

	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRL1ENA_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1, SMU_GCLKCTRL1_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRLENA_VAL_CLR, r1)

	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2, SMU_GCLKCTRL2_VAL, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRLENA_VAL_CLR, r1)
	
	/* set DOMAIN_DIV */
	STORE_WORD(r0, SMU_CLK_DOMAIN_DIV, SMU_CLK_DOMAIN_DIV_VAL, r1)
	STORE_WORD(r0, SMU_PCTL_SDR, SMU_PCTL_SDR_VAL, r1)
	
	// --- set SDRAM timigs
	STORE_WORD(r0, SMU_SDR_CLK_DLY, SMU_SDR_CLK_DLY_VAL, r1)
	STORE_WORD(r0, SMU_SDR_UDCLK_DLY, SMU_SDR_UDCLK_DLY_VAL, r1)
	STORE_WORD(r0, SMU_SDR_LDCLK_DLY, SMU_SDR_LDCLK_DLY_VAL, r1)
#ifdef	PLL_48MHZ
#else
	STORE_WORD(r0, SMU_PULLCTL_SDR, SMU_PULLCTL_SDR_VAL, r1)
#endif

	STORE_WORD(r0, SMU_DRV_SDRAM, SMU_DRV_SDRAM_VAL, r1)

	SET_BASEREG	(r0, FIF_SDR_BASE)
#if 1	// no needs for elpida SDR
	STORE_WORD(r0, FIF_SDRConfigB, FIF_SDRConfigB_VAL, r1)
#endif
	STORE_WORD(r0, FIF_SDRConfigA, FIF_SDRConfigA_VAL, r1)
	STORE_WORD(r0, FIF_SDRPowerMng, FIF_SDRPowerMng_VAL, r1)
	STORE_WORD(r0, FIF_SDRModeReg, FIF_SDRModeReg_VAL, r1)
	STORE_WORD(r0, FIF_SDRCmdCtrl, FIF_SDRCmdCtrl_RSM_VAL_1, r1)

	// --- wait for SDR
	MOV		r1, #0x00000000
SDRINITWAIT_R:
	ADD		r1, r1, #1
	CMP		r1, #4096
	NOP
	BNE		SDRINITWAIT_R

#if 0
	STORE_WORD(r0, FIF_SDRCmdCtrl, FIF_SDRCmdCtrl_RSM_VAL_2, r1)
#endif

	SET_BASEREG(r0, SMU_BASE)

	// --- start PLL
	MOV	r7,	#(SMU_INT_RAW_STATUS_VAL)

	STORE_WORD(r0, SMU_GCLKEN_POL, SMU_GCLKEN_POL_VAL, r1)

	STORE_WORD(r0, SMU_PLLLOCK_CTRL, SMU_PLLLOCK_CTRL_VAL, r1)
	STORE_WORD(r0, SMU_LPLL_CTR1, SMU_LPLL_CTR1_VAL, r1)
	/* LPLL enable */
	STORE_WORD(r0, SMU_LPLL_CTR2, SMU_LPLL_CTR2_VAL, r1)
	STORE_WORD(r0, SMU_HPLL_CTR1, SMU_HPLL_CTR1_VAL, r1)
	STORE_WORD(r0, SMU_HPLL_CTR2, SMU_HPLL_CTR2_VAL, r1)
	STORE_WORD(r0, SMU_HPLL_CTR3, SMU_HPLL_CTR3_VAL, r1)
	/* choice HPLL */
	STORE_WORD(r0, SMU_PLLSEL2, SMU_PLLSEL2_VAL, r1)
	/* HPLL enable */
	STORE_WORD(r0, SMU_HPLL_CTR4, SMU_HPLL_CTR4_VAL, r1)
	/* clear Interrupt */
	STORE_WORD(r0, SMU_INT_CLEAR, SMU_INT_CLEAR_VAL, r1)
	/* select PLL */
	SET_BASEREG(r1, SMU_PLLSEL_VAL)
	LDR	r6, [r0, #(SMU_PLLSEL & 0xfff)]
	CMP	r6, r1
	NOP
	BEQ	CLK_PLL_R
	nop
	nop
	nop
	nop

	b	1f
	
	// --- Wait for PLL

	.align	ICACHE_LINE_SIZE_ORD
1:
	STR	r1, [r0, #(SMU_PLLSEL & 0xfff)]

CLK192_WAIT_R:
	LDR	r6, [r0, #(SMU_INT_RAW_STATUS & 0xfff)]
	CMP	r6, r7
	NOP
	BNE	CLK192_WAIT_R

CLK_PLL_R:
	//;; for UART console

	SET_BASEREG(r0, SMU_BASE)

	STORE_WORD(r0, SMU_RESETREQ1AENA, SMU_RESETREQ1AENA_AB1, r1)
	STORE_WORD(r0, SMU_RESETREQ1A, SMU_RESETREQ1A_RSM_VAL, r1)

	STORE_WORD(r0, SMU_U70_SCLK_DIV, SMU_U70_SCLK_DIV_VAL, r1)
	STORE_WORD(r0, SMU_U70_SCLK_SEL, SMU_U70_SCLK_SEL_VAL, r1)

	STORE_WORD(r0, SMU_AB1_U70WAITCTRL, SMU_AB1_U70WAITCTRL_VAL, r1)

	STORE_WORD(r0, SMU_RESETREQ1BENA, SMU_RESETREQ1BENA_U70, r1)
	STORE_WORD(r0, SMU_RESETREQ1B, SMU_RESETREQ1B_RSM_VAL, r1)

        MOV     r1, #0x00000000		/* all disable */
        STR     r1, [r0, #(SMU_RESETREQ1AENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1BENA & 0x00ff)]

#ifdef	PROV_BOOT
#else	/* normal boot */
	/* Enable Automatic Clock Control */
	SET_BASEREG(r0, SMU_BASE)
	STORE_WORD(r0, SMU_APBCLKCTRL, SMU_APBCLKCTRL_VAL, r1)
	STORE_WORD(r0, SMU_AHBCLKCTRL0, SMU_AHBCLKCTRL0_VAL, r1)
	STORE_WORD(r0, SMU_AHBCLKCTRL1, SMU_AHBCLKCTRL1_VAL, r1)
	STORE_WORD(r0, SMU_CLKCTRL, SMU_CLKCTRL_VAL, r1)

	/* Auto Frequency Change */
	STORE_WORD(r0, SMU_AUTO_FREQ_CHANGE, SMU_AUTO_FREQ_CHANGE_VAL, r1)
	STORE_WORD(r0, SMU_PLL_DOWN_EN, SMU_PLL_DOWN_EN_VAL, r1)
#endif

	// Disable ICache to avoid cache aliases
	mov	r1, #0x1000
	mvn	r1, r1
	mrc	p15, 0, r0, c1, c0, 0
	and	r0, r0, r1
	mcr	p15, 0, r0, c1, c0, 0

//// -------------------------------------------------------------------------
#ifdef WARMBOOT_SRAM
	    SET_BASEREG(lr, SRAM_WARM_PM_ADDR)
#endif
	mov	pc, lr

END_INIT_FUNC (boot_pll_to_warmboot)
 
BEGIN_INIT_FUNC (warmboot_pwon_size)
    .word   . - boot_pll_to_warmboot

BEGIN_INIT_FUNC (warmboot_copy_to_sram)
    adr r0, boot_pll_to_warmboot    /* r0 <- source position   */
    SET_BASEREG(r1, SRAM_WARM_UB_ADDR)  /* r1 <- target position   */

    adr r2, warmboot_copy_to_sram   /* r2 <- end position   */
copy_loop:
    ldmia   r0!, {r3-r10}       /* copy from source address [r0]    */
    stmia   r1!, {r3-r10}       /* copy to   target address [r1]    */
    cmp r0, r2          /* until source end addreee [r2]    */
    blt copy_loop

	mov	pc, lr
END_INIT_FUNC (warmboot_copy_to_sram)


        .end

#else
#ifdef	CONFIG_MP200_PLL
# if	( CONFIG_MP200_PLL == 192 )
#  define	PLL_192MHZ
# else
#  if	( CONFIG_MP200_PLL == 150 )
#   define	PLL_150MHZ
#  else
#   error
#  endif
# endif
#endif

//; --- for MP211, system managemant unit
#define	SMU_BASE	        0xc8010000

#define	SMU_RESETCTRL0          0xc8010000
#define	SMU_RESETREQ0           0xc8010004
#define	SMU_RESETREQ0ENA        0xc8010008
#define	SMU_RESETREQ1           0xc801000c
#define	SMU_RESETREQ1ENA        0xc8010010
#define	SMU_RESETCTRL1		0xc8010014

/* base address and range registers for Chip Select 0 to 5 */
/* for I/O or memory devices */
#define	SMU_AB0_CS0BASEADD	0xc8010320
#define	SMU_AB0_CS1BASEADD	0xc8010324
#define	SMU_AB0_CS2BASEADD	0xc8010328
#define	SMU_AB0_CS3BASEADD	0xc801032c
#define	SMU_AB0_CS4BASEADD	0xc8010330
#define	SMU_AB0_CS5BASEADD	0xc8010334
#define	SMU_AB0_CS0BITCOMP	0xc8010338
#define	SMU_AB0_CS1BITCOMP	0xc801033c
#define	SMU_AB0_CS2BITCOMP	0xc8010340
#define	SMU_AB0_CS3BITCOMP	0xc8010344
#define	SMU_AB0_CS4BITCOMP	0xc8010348
#define	SMU_AB0_CS5BITCOMP	0xc801034c

/* Chip Select for Flash Memories */
#define	SMU_AB0_CS0BASEADD_VAL	0
#define	SMU_AB0_CS0BITCOMP_VAL	0xfe000000
#define	SMU_AB0_CS1BASEADD_VAL	0x02000000
#define	SMU_AB0_CS1BITCOMP_VAL	0xfe000000
#ifdef NANDFLASH
# define	SMU_AB0_CS2BASEADD_VAL	0x04000000
# define	SMU_AB0_CS2BITCOMP_VAL	0xfe000000
#endif
	
/* Chip Select for EBC/FPGA itself */
/* access to address range 0x203e0000~0x203effff asserts CS4 */
#define	SMU_AB0_CS4BASEADD_VAL_DEF	0x2ffe0000
#define	SMU_AB0_CS4BASEADD_VAL	0x203e0000
#define	SMU_AB0_CS4BITCOMP_VAL	0xffff0000

/* Chip Select for Ether/Wireless LAN/MA-3D/D9930 */
/* access to address range 0x20000000~0x2007ffff asserts CS5 */
#define	SMU_AB0_CS5BASEADD_VAL	0x20000000
#define	SMU_AB0_CS5BITCOMP_VAL	0xfff80000

/* Chip Select for PCMCIA */
/* access to address range 0x08100000~0x0ffffff asserts CS3 */
#define	SMU_AB0_CS3BASEADD_VAL	0x08100000
#define	SMU_AB0_CS3BITCOMP_VAL	0xfe000000

/* timing registers for Chip Select 0 to 5 */
/* for I/O or memory devices */
#define	SMU_AB0_CS0WAITCTL		0xc8010350		// flash region
#define	SMU_AB0_CS1WAITCTL		0xc8010354
#define	SMU_AB0_CS2WAITCTL		0xc8010358
#define	SMU_AB0_CS3WAITCTL		0xc801035c
#define	SMU_AB0_CS4WAITCTL		0xc8010360
#define	SMU_AB0_CS5WAITCTL		0xc8010364
#define SMU_AB0_CS0WAITCTL_W		0xc80103a0		// flash region
#define SMU_AB0_CS1WAITCTL_W		0xc80103a4

//;;; --- for DSP control

#define	SMU_DSP_ADDRCONV	0xc801021c

//;;; --- for SDRAM control
	
#define	FIF_DDR_BASE		0x4C001000
#define	FIF_DDRConfigA		0x4C001000
#define	FIF_DDRConfigB		0x4C001004
#define	FIF_DDRPowerMng		0x4C001008
#define	FIF_DDRCmdCtrl		0x4C001100
#define	FIF_DDRModeReg		0x4C001110
#define	FIF_ContCmdAddr	

#define	SMU_PLLSEL		0xc8010080
#define	SMU_PLL1CTRL0		0xc8010084
#define	SMU_PLL1CTRL1		0xc8010088
#define	SMU_PLL1CTRL2		0xc801008c
#define	SMU_PLLLOCKTIME		0xc80100a0

#define	SMU_DDR_M1CLKR_DLY	0xC80101D0
#define	SMU_DDR_M4CLKW_DLY	0xC80101D4
#define	SMU_DDR_MCLK_DLY	0xC80101DC
#define	SMU_DDR_DQSOUT_DLY	0xC80101E0
#define	SMU_DDR_DQSOUT12M_DLY	0xC80101E4
#define	SMU_DDR_DQS_I_DLY	0xC80101E8
#define	SMU_DDR_M1CLKR_ST	0xC80101EC	

#define	SMU_BUFSEL0		0xC8010300
#define	SMU_BUFSEL1		0xC8010304

//;;; --- for UART control

#define	SMU_UART_PLLSEL		0xc80100b4
#define	SMU_DIVU70SCLK		0xc8010160
#define	SMU_DIVU71SCLK		0xc8010164
#define	SMU_DIVU72SCLK		0xc8010168

#define	SMU_AB1_U70WAITCTRL	0xC80103C0
#define	SMU_AB1_U71WAITCTRL	0xC80103C4
#define	SMU_AB1_U72WAITCTRL	0xC80103C8
#define	SMU_AB1_U73WAITCTRL	0xC80103CC

#define	SMU_PLL3CTRL0    	0xC80100A8
#define	SMU_PLL3CTRL1    	0xC80100AC

//;;; --- for Automatic Power Control

#define	SMU_AHBCLKCTRL0		0xC8010180
#define	SMU_AHBCLKCTRL1		0xC8010188
#define	SMU_APBCLKCTRL		0xC8010190
#define	SMU_CLKCTRL		0xc80101b8

#define	PB0_BASE		0x40110000
#define	PB0_TI1PCLKCTRL		0x40110000
#define	PB0_A3DPCLKCTRL		0x40110018
#define	PB0_FIFPCLKCTRL		0x4011001c
#define	PB0_ROTCLKCTRL		0x40110020
#define	PB0_DMAPCLKCTRL		0x40110024
#define	PB0_IMGPCLKCTRL		0x40110028
#define	PB0_CAMPCLKCTRL		0x40110030
#define	PB0_PM0PCLKCTRL		0x40110034
#define	PB0_SDIPCLKCTRL		0x40110044
#define	PB0_SWTPCLKCTRL		0x4011004C

#define	PB1_BASE		0xc0090000
#define	PB1_TI0PCLKCTRL		0xC0090000
#define	PB1_INTPCLKCTRL		0xC0090008
#define	PB1_SMUPCLKCTRL		0xC009000c
#define	PB1_LCDPCLKCTRL		0xC0090010
#define	PB1_MWIPCLKCTRL		0xC0090018
#define	PB1_SI0PCLKCTRL		0xC009001c
#define	PB1_PMUPCLKCTRL		0xC0090024

//;;; --- external port
	
#define	SMU_IOCTRL		0xc8010218		// GIO<->U71,U72

//;;; --- for LCD control

#define	SMU_LCD_PLLSEL   	0xC80100B0
#define	SMU_DIVLCDLCLK   	0xC8010134
#define	SMU_CLKEN_POL    	0xC80101BC

#define	LCD_BASE		0xC0040000
#define	LCD_CONTROL		0xC0040000

//;;; --- for clock control

#define	SMU_GCLKCTRL0		0xC8010198
#define	SMU_GCLKCTRL0ENA	0xC801019C
#define	SMU_GCLKCTRL1		0xC80101A0
#define	SMU_GCLKCTRL1ENA	0xC80101A4
#define	SMU_GCLKCTRL2		0xC80101A8
#define	SMU_GCLKCTRL2ENA	0xC80101AC

#define	SWT_BASE		0xcc000000
#define	SWT_TRACE_CLK		0xcc000000

//;;; --- for DSP-debugger <-> ARM core I/F

#define	SWT_PE0_INT_MASK_SET	0x80000040

//;;; --- Auto Frequency Change

#define SMU_AUTO_FREQ_CHANGE	0xC8010194

//;;; ---------------------------------------------------------------------
//;;; -------  Each values
//;;; ---------------------------------------------------------------------

//;;; --- reset control

#define	SMU_RESETREQ0_USB_RST	0x08000000
#define	SMU_RESETREQ0_SDM_RST	0x00100000
#define	SMU_RESETREQ0_PE12_RST	0x0000003c		// PE1,2 reset on pmu drv

#define	SMU_RESETREQ1_MMM_RST	0x00010000
#define	SMU_RESETREQ1_MWI_RST	0x00008000		// uwire enabled on PMU
#define	SMU_RESETREQ1_SI1_RST	0x00000400
#define	SMU_RESETREQ1_MSP_RST	0x00000200
#define	SMU_RESETREQ1_SDI_RST	0x00000100

#define	SMU_RESETREQ0_VAL       0x37eff6c3
#define	SMU_RESETREQ0_RSM_VAL   0x37efffc3
#define	SMU_RESETREQ1_VAL       0x0002bcff
#define	SMU_RESETREQ0ENA_AB1	0x00008000
#define	SMU_RESETREQ0ENA_U70	0x00800000
#define	SMU_RESETREQ0ENA_U71	0x01000000
#define	SMU_RESETREQ0ENA_U72	0x02000000

//;;; --- reset after resume
//;;; ---	clock disabled devices need a reset

#define	SMU_RESETREQ0_RESUME_L1_VAL	(SMU_RESETREQ0_USB_RST | \
					 SMU_RESETREQ0_SDM_RST)
	
#define	SMU_RESETREQ1_RESUME_L1_VAL	(SMU_RESETREQ1_MMM_RST | \
					 SMU_RESETREQ1_SI1_RST | \
					 SMU_RESETREQ1_MSP_RST | \
					 SMU_RESETREQ1_SDI_RST)

#define	SMU_RESETCTRL1_RESUME_L1_VAL	1

#define	SWT_PE0_INT_MASK_SET_VAL	0x00000007

//;;; ---------------------------------------------------------------------

#define	SMU_DSP_ADDRCONV_VAL	0x00000001

//;;; ---------------------------------------------------------------------
//;;; AB0 wait ctrl
#define	SMU_AB0_CS0WAITCTL_VAL	AB0CS01WAIT
#define	SMU_AB0_CS1WAITCTL_VAL	AB0CS01WAIT
#define	SMU_AB0_CS0WAITCTL_W_VAL	(AB0CS01WAIT & ~0xff0000ff)
#define	SMU_AB0_CS1WAITCTL_W_VAL	(AB0CS01WAIT & ~0xff0000ff)
#define	SMU_AB0_CS5WAITCTL_VAL	AB0CS01WAIT
#define	EBC_WRZ_WAIT_VAL	((AB0CS01WAIT & 0x0000ff00) >> 8)

//;;; -- for SI1 SCLK (Clr Board Validation Mode)
#define	SMU_GCLKCTRL2_VAL_SI1		0xffffffbf
#define	SMU_GCLKCTRL2ENA_VAL_SI1	0x00000040
#define	SMU_GCLKCTRL2ENA_VAL_CLR	0xffffffff


#ifdef	ONDEMAND_CLK
# define	SMU_GCLKCTRL0ENA_VAL_CLR	0xffffffff
# define	SMU_GCLKCTRL1ENA_VAL_CLR	0xffffffff
//#ifdef	SUSPEND_RESUME
//# define	SUSPEND_RESUME_USBCLKON
//#endif
//;;; -- for GCLKCTRL0
# define	SMU_GCLKCTRL0_LCD_LCLK	0x00040000
# define	SMU_GCLKCTRL0_LCD_PCLK	0x00020000
# define	SMU_GCLKCTRL0_LCD_CLK	0x00010000
# define	SMU_GCLKCTRL0_IMG_PCLK	0x00000800
# define	SMU_GCLKCTRL0_IMG_CLK	0x00000400
# define	SMU_GCLKCTRL0_MSE_CLK	0x00000040
# ifdef SUSPEND_RESUME_USBCLKON
//;;;   to prevent lost reset on MSE
#  define	SMU_GCLKCTRL0ENA_VAL_ONDEMAND	(0)
#  define	SMU_GCLKCTRL0ENA_RSM_VAL_ONDEMAND	(0)
# else
#  define	SMU_GCLKCTRL0ENA_VAL_ONDEMAND	(SMU_GCLKCTRL0_MSE_CLK |\
	SMU_GCLKCTRL0_LCD_LCLK | SMU_GCLKCTRL0_LCD_PCLK |\
	SMU_GCLKCTRL0_LCD_CLK | SMU_GCLKCTRL0_IMG_PCLK | SMU_GCLKCTRL0_IMG_CLK)
#  define	SMU_GCLKCTRL0ENA_RSM_VAL_ONDEMAND	(SMU_GCLKCTRL0_MSE_CLK)
# endif
# define	SMU_GCLKCTRL0_VAL_ONDEMAND	(~SMU_GCLKCTRL0ENA_VAL_ONDEMAND)
# define	SMU_GCLKCTRL0_RSM_VAL_ONDEMAND	(~SMU_GCLKCTRL0ENA_RSM_VAL_ONDEMAND)
//;;; -- for GCLKCTRL1
# define	SMU_GCLKCTRL1_MSP_PCLK	0x80000000
# define	SMU_GCLKCTRL1_MSP_SCLK	0x40000000
# define	SMU_GCLKCTRL1_SDI_PCLK	0x20000000
# define	SMU_GCLKCTRL1_SDI_SCLK	0x10000000
# define	SMU_GCLKCTRL1_USB_SCLK	0x00080000
# define	SMU_GCLKCTRL1_USB_CLK	0x00040000

# ifdef SUSPEND_RESUME_USBCLKON
#  define	SMU_GCLKCTRL1ENA_VAL_ONDEMAND	(SMU_GCLKCTRL1_MSP_PCLK |\
	SMU_GCLKCTRL1_MSP_SCLK | SMU_GCLKCTRL1_SDI_PCLK |\
	SMU_GCLKCTRL1_SDI_SCLK)
# else // SUSPEND_RESUME_USBCLKON
#  define	SMU_GCLKCTRL1ENA_VAL_ONDEMAND	(SMU_GCLKCTRL1_MSP_PCLK |\
	SMU_GCLKCTRL1_MSP_SCLK | SMU_GCLKCTRL1_SDI_PCLK |\
	SMU_GCLKCTRL1_SDI_SCLK | SMU_GCLKCTRL1_USB_SCLK |\
	SMU_GCLKCTRL1_USB_CLK)
# endif
# define	SMU_GCLKCTRL1_VAL_ONDEMAND	(~SMU_GCLKCTRL1ENA_VAL_ONDEMAND)

//;;; -- for GCLKCTRL2
# define	SMU_GCLKCTRL2_LCD_CLK	0x40000000
# define	SMU_GCLKCTRL2_SDM_CLK	0x00800000
# define	SMU_GCLKCTRL2_SDM_SCLK	0x00400000
# define	SMU_GCLKCTRL2_MMM_CLK	0x00000200
# define	SMU_GCLKCTRL2_MWI_SCLK	0x00000100
# define	SMU_GCLKCTRL2_SI1_CLK	0x00000040

# define	SMU_GCLKCTRL2ENA_VAL_ONDEMAND	(SMU_GCLKCTRL2_SDM_CLK |\
			SMU_GCLKCTRL2_SDM_SCLK | SMU_GCLKCTRL2_MMM_CLK |\
			SMU_GCLKCTRL2_SI1_CLK | SMU_GCLKCTRL2_LCD_CLK)
# define	SMU_GCLKCTRL2ENA_RSM_VAL_ONDEMAND	(SMU_GCLKCTRL2_SDM_CLK |\
			SMU_GCLKCTRL2_SDM_SCLK | SMU_GCLKCTRL2_MMM_CLK |\
			SMU_GCLKCTRL2_SI1_CLK )

# define	SMU_GCLKCTRL2_VAL_ONDEMAND	(~SMU_GCLKCTRL2ENA_VAL_ONDEMAND)
# define	SMU_GCLKCTRL2_RSM_VAL_ONDEMAND	(~SMU_GCLKCTRL2ENA_RSM_VAL_ONDEMAND)

# define	SWT_TRACE_CLK_MASK	0x00000001
# define	SWT_TRACE_CLK_VAL	(~SWT_TRACE_CLK_MASK)
#endif

//;;; PLL frequency

#define	SMU_PLLLOCKTIME_VAL	0x00000003	//; lockup 510us
#define	SMU_PLLSEL_VAL   	0x0000000A	//; use PLL,auto standby off,FIF hand shake on
#define	SMU_PLLSEL_STATE_MASK	0x00000003
#ifdef	PLL_192MHZ
# define	SMU_PLL1CTRL0_VAL 	0x0000011f
# define	SMU_PLL1CTRL1_VAL 	0x00000001
#endif
#ifdef	PLL_150MHZ
# define	SMU_PLL1CTRL0_VAL 	0x00000018
# define	SMU_PLL1CTRL1_VAL 	0x00000001
#endif

#define	SMU_PLL1CTRL2_VAL	0x00000000		//; start 192MHz
	
//;;; --- for PLL3 setting
#define	SMU_PLL3CTRL0_VAL	0x0000000D		//; 58.7MHz
#define	SMU_PLL3CTRL1_VAL	0x00000000		//; start

//;;; --- for LCD setting

#define	SMU_LCD_PLLSEL_VAL	0x00000003		//; use 12MHz
#define	SMU_DIVLCDLCLK_VAL	0x00000001		//; LCD_PXCLK 6MHz 
#define	LCD_CONTROL_VAL		0x00000146

#define	SMU_CLKEN_POL_VAL	0x00000040		//; SRC_CLKEN_LCD porality change

//;;; -- for DDR/FIFO setting

#define	SMU_DDR_M1CLKR_ST_VAL	0x0

#if defined(CONFIG_MP200_SDRAM_INTERNAL) && (CONFIG_MP200_PLL == 192)
# define	SMU_BUFSEL1_VAL		0x2000a
#else
# define	SMU_BUFSEL1_VAL		0x3000f
#endif

#if ( CONFIG_MP200_PLL == 150 )
# define	SMU_DDR_DQSOUT_DLY_VAL	0xf
# define	SMU_DDR_M1CLKR_DLY_VAL	0xff
# define	SMU_DDR_M4CLKW_DLY_VAL	0x3f
# define	SMU_DDR_MCLK_DLY_VAL	0x1
# define	SMU_DDR_DQSOUT12M_DLY_VAL	0xff
# define	SMU_DDR_DQS_I_DLY_VAL	0x1ff
#else // CONFIG_MP200_PLL == 192(others not supported)
# define	SMU_DDR_DQSOUT_DLY_VAL	0xff
# define	SMU_DDR_M1CLKR_DLY_VAL	0x1
# define	SMU_DDR_M4CLKW_DLY_VAL	0x3f
# define	SMU_DDR_MCLK_DLY_VAL	0x7
# define	SMU_DDR_DQSOUT12M_DLY_VAL	0x1ff
# ifdef CONFIG_MP200_SDRAM_INTERNAL
#  define	SMU_DDR_DQS_I_DLY_VAL	0x7f
# else
#  define	SMU_DDR_DQS_I_DLY_VAL	0xfff
# endif
#endif
	
//;;; --- for DDR setting
#define	FIF_DDRConfigA_B01_VAL	3
#if (CONFIG_MP200_PLL == 150)
# define	FIF_DDRModeReg_VAL	0x00400033
#elif defined(CONFIG_MP200_SDRAM_INTERNAL) && (CONFIG_MP200_PLL == 192)
# define	FIF_DDRModeReg_VAL	0x00400033
#else // CONFIG_MP200_PLL == 192(others not supported)
# define	FIF_DDRModeReg_VAL	0x00000033
#endif
#define	FIF_DDRPowerMng_VAL	0x80021120
#define	FIF_DDRCmdCtrl_VAL_1	0x0000013B
#define	FIF_DDRCmdCtrl_VAL_2	0x00000335
#define	FIF_DDRCmdCtrl_VAL_RSME1	0x0000013a
#define	FIF_DDRCmdCtrl_VAL_RSME2	0x00000335
#define	FIF_DDRConfigA_VAL	(0x43233110 | FIF_DDRConfigA_B01_VAL)
#ifdef CONFIG_MP200_DDRDRIVE_IS_DEFAULT
#define	FIF_DDRConfigB_VAL	0x00003203	/* DBPartEna = ON is default*/
#else
#define	FIF_DDRConfigB_VAL	0x00803203	/* Set DBPartEna ON */
#endif

//;;; --- for UART settings

#ifdef USE_GIOP2x
# define	SMU_IOCTRL_VAL_B	0x00000000		// U71,U72-->MSE, GIO
#else	// !USE_GIOP2x	
# ifdef USE_MSE_ICE
#  define	SMU_IOCTRL_VAL_B	0x00000026		// MSE, GIO-->U71,U72
# else	// !USE_MSE_ICE
#  define	SMU_IOCTRL_VAL_B	0x00000006		// GIO-->U71,U72
# endif // !USE_MSE_ICE
#endif // !USE_GIOP2x
#define	SMU_IOCTRL_VAL		0x00000100 | SMU_IOCTRL_VAL_B	// use uWire(not use SPI)

#define	SMU_DIVU70SCLK_VAL	0x00000000
#define	SMU_DIVU71SCLK_VAL	0x00000000
#define	SMU_DIVU72SCLK_VAL	0x00000000
#define	SMU_UART_PLLSEL_VAL	0x00000333
#define	SMU_AB1_U70WAITCTRL_VAL	0x00010200
#define	SMU_AB1_U71WAITCTRL_VAL	0x00010200
#define	SMU_AB1_U72WAITCTRL_VAL	0x00010200


//;;; --- for clock control
	
#ifdef	NOSRAM
# define	SMU_GCLKCTRL1_VAL_NOSRAM	0xfffff7ff
# define	SMU_GCLKCTRL1ENA_VAL_NOSRAM	0x00000800
# define	SMU_GCLKCTRL1ENA_VAL_CLR	0
#endif /* !NOSRAM */

//;;; --- for Automatic Power Control

#ifndef CONNECT_ICE
#define	SMU_AHBCLKCTRL0_VAL	0x0001FFFF		/* AutoPowerControl PEx ON */
#define	SMU_AHBCLKCTRL1_VAL	0x000000FF		/* SWT ON */
#else
#define	SMU_AHBCLKCTRL0_VAL	0x0001FFF8		/* AutoPowerControl PEx OFF */
#define	SMU_AHBCLKCTRL1_VAL	0x000000FE		/* SWT OFF */
#endif
#define	SMU_APBCLKCTRL_VAL	0x003FFFFF
#define	SMU_CLKCTRL_VAL		0x0000001F

#define	AB0_BASE		0x2fff0000
#define	AB0_FLASHCOMSET		0x2fff0000

#define	AB0_FLASHCOMSET_VAL	0x00000013

/*
 * On Board Devices
 */
#define	EBC_BASE		0x203E0000
#define	EBC_LAN_RST		0x203e005C

#define	EBC_DEF_BASE		0x2ffE0000
#define	EBC_WRZ_WAIT		0x2ffe0070

#define	EBC_LAN_RST_VAL		1

/*
 * SyncBurst Mode flag
 */
#define SYNCBURST_MODE_BASE	0xa007f000
#define SYNCBURST_MODE_OFFSET	0x00000a00
#define SYNCBURST_TRUE		0xffffffff
#define SYNCBURST_FALSE		0x00000000

/*
 * Auto Frequency Change
 */
#define SMU_AUTO_FREQ_CHANGE_VAL 0xE0321001

/*
 * Peripheral init flag
 */
#define	PERIPHERAL_INIT_BASE	0xa007f000
#define	PERIPHERAL_INIT_PE1	0xa007fd00
#define	PERIPHERAL_INIT_PE2	0xa007fd04
#define		PERIPHERAL_NOT_YET	0x00000000
#define		PERIPHERAL_EXECUTE	0x76000000
#define		PERIPHERAL_FINISH	0x00003200

BEGIN_INIT_FUNC (platformsetup)
	.set	REG_PID, 0x80000000
	.set	ICACHE_LINE_SIZE_ORD, 5

	mov	r1, #REG_PID
	ldr	r0, [r1]
	cmp	r0, #0
	bne	.Lreset_pe12

.Lreset_pe0:
	SET_BASEREG(r0, PERIPHERAL_INIT_BASE)
	STORE_WORD(r0, PERIPHERAL_INIT_PE1, PERIPHERAL_EXECUTE, r1)
	STORE_WORD(r0, PERIPHERAL_INIT_PE2, PERIPHERAL_EXECUTE, r1)

	// --- stop NMI to dsp
	SET_BASEREG(r0, REG_PID)
	mov	r1, #(SWT_PE0_INT_MASK_SET_VAL)
	str	r1, [r0, #(SWT_PE0_INT_MASK_SET & 0xfff)]

	// Enable ICache to prevent fetches under delay-control operations
	mrc	p15, 0, r0, c1, c0, 0
	orr	r0, r0, #0x1000
	mcr	p15, 0, r0, c1, c0, 0

	// --- Sync Burst flag init
	SET_BASEREG(r0, SYNCBURST_MODE_BASE)
	STORE_WORD(r0, SYNCBURST_MODE_OFFSET, SYNCBURST_FALSE, r1)

	SET_BASEREG(r0, SMU_BASE)
	
	// --- relase reset
        MVN     r1, #0x00000000
        STR     r1, [r0, #(SMU_RESETREQ0ENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1ENA & 0x00ff)]
	LDR	r2, [r0, #(SMU_RESETREQ0 & 0x00ff)]
	AND	r2, r2, #0x3C		/* Read reset status of PE1, PE2 */
	ADD	r2, r2, #(SMU_RESETREQ0_VAL & 0xff000000)
	ADD	r2, r2, #(SMU_RESETREQ0_VAL & 0x00ff0000)
	ADD	r2, r2, #(SMU_RESETREQ0_VAL & 0x0000ff00)
	ADD	r2, r2, #(SMU_RESETREQ0_VAL & 0x000000ff)
	STR	r2, [r0, #(SMU_RESETREQ0 & 0x00ff)]
	STORE_WORD(r0, SMU_RESETREQ1, SMU_RESETREQ1_VAL, r1)

	// --- async bridge setting
	STORE_WORD(r0, SMU_AB0_CS0BASEADD, SMU_AB0_CS0BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS0BITCOMP, SMU_AB0_CS0BITCOMP_VAL, r1)

	STORE_WORD(r0, SMU_AB0_CS1BASEADD, SMU_AB0_CS1BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS1BITCOMP, SMU_AB0_CS1BITCOMP_VAL, r1)

#ifdef	NANDFLASH
	STORE_WORD(r0, SMU_AB0_CS2BASEADD, SMU_AB0_CS2BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS2BITCOMP, SMU_AB0_CS2BITCOMP_VAL, r1)
#endif

	STORE_WORD(r0, SMU_AB0_CS5BASEADD, SMU_AB0_CS5BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS5BITCOMP, SMU_AB0_CS5BITCOMP_VAL, r1)

	STORE_WORD(r0, SMU_AB0_CS3BASEADD, SMU_AB0_CS3BASEADD_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS3BITCOMP, SMU_AB0_CS3BITCOMP_VAL, r1)

	STORE_WORD(r0, SMU_AB0_CS4BASEADD, SMU_AB0_CS4BASEADD_VAL_DEF, r1)
	STORE_WORD(r0, SMU_AB0_CS4BITCOMP, SMU_AB0_CS4BITCOMP_VAL, r1)

	SET_BASEREG(r2, EBC_DEF_BASE)

	SET_BASEREG(r3, EBC_WRZ_WAIT_VAL)
	SET_BASEREG(r4, SMU_AB0_CS0WAITCTL_VAL)
	SET_BASEREG(r5, SMU_AB0_CS1WAITCTL_VAL)
	mov	r6, #32

	b	1f
	
	.align	ICACHE_LINE_SIZE_ORD
1:
	str	r3, [r2, #(EBC_WRZ_WAIT & 0xfff)]
2:
	subs	r6, r6, #1
	bgt	2b
	str	r4, [r0, #(SMU_AB0_CS0WAITCTL & 0xfff)]
	str	r5, [r0, #(SMU_AB0_CS1WAITCTL & 0xfff)]

	STORE_WORD(r0, SMU_AB0_CS0WAITCTL_W, SMU_AB0_CS0WAITCTL_W_VAL, r1)
	STORE_WORD(r0, SMU_AB0_CS1WAITCTL_W, SMU_AB0_CS1WAITCTL_W_VAL, r1)

	SET_BASEREG(r2, AB0_BASE)
	STORE_WORD(r2, AB0_FLASHCOMSET, AB0_FLASHCOMSET_VAL, r1)

	// -- modify CS4BASEADD to simplify address transration rule on linux kernel
	STORE_WORD(r0, SMU_AB0_CS4BASEADD, SMU_AB0_CS4BASEADD_VAL, r1)
	
	/* Disable unused clock lines */
#ifdef	ONDEMAND_CLK
	SET_BASEREG(r3, SWT_BASE)
	STORE_WORD(r3, SWT_TRACE_CLK, SWT_TRACE_CLK_VAL, r1)

	STORE_WORD(r0, SMU_GCLKCTRL0ENA, SMU_GCLKCTRL0ENA_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL0, SMU_GCLKCTRL0_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL0ENA, SMU_GCLKCTRL0ENA_VAL_CLR, r1)

	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRL1ENA_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1, SMU_GCLKCTRL1_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRL1ENA_VAL_CLR, r1)

	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2, SMU_GCLKCTRL2_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_VAL_CLR, r1)

#else	// ONDEMAND_CLK
	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_VAL_SI1, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2, SMU_GCLKCTRL2_VAL_SI1, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_VAL_CLR, r1)
#endif // ONDEMAND_CLK
		
#ifdef	NOSRAM
	// --- to stop clock lines to the SRAM region	
	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRL1ENA_VAL_NOSRAM, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1, SMU_GCLKCTRL1_VAL_NOSRAM, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRL1ENA_VAL_CLR, r1)
#endif

	// --- set SDRAM timigs to meet PLL192MHz
	STORE_WORD(r0, SMU_DDR_M1CLKR_DLY, SMU_DDR_M1CLKR_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_M4CLKW_DLY, SMU_DDR_M4CLKW_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_MCLK_DLY, SMU_DDR_MCLK_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_DQSOUT_DLY, SMU_DDR_DQSOUT_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_DQSOUT12M_DLY, SMU_DDR_DQSOUT12M_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_DQS_I_DLY, SMU_DDR_DQS_I_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_M1CLKR_ST, SMU_DDR_M1CLKR_ST_VAL, r1)

	STORE_WORD(r0, SMU_BUFSEL1, SMU_BUFSEL1_VAL, r1)


	SET_BASEREG	(r0, FIF_DDR_BASE)
#if 1	// no needs for elpida DDR
	STORE_WORD(r0, FIF_DDRConfigB, FIF_DDRConfigB_VAL, r1)
#endif
	STORE_WORD(r0, FIF_DDRConfigA, FIF_DDRConfigA_VAL, r1)
	STORE_WORD(r0, FIF_DDRPowerMng, FIF_DDRPowerMng_VAL, r1)
	STORE_WORD(r0, FIF_DDRModeReg, FIF_DDRModeReg_VAL, r1)
	STORE_WORD(r0, FIF_DDRCmdCtrl, FIF_DDRCmdCtrl_VAL_1, r1)

	// --- wait for DDR
	MOV		r1, #0x00000000
DDRINITWAIT:
	ADD		r1, r1, #1
	CMP		r1, #4096
	NOP
	BNE		DDRINITWAIT

	STORE_WORD(r0, FIF_DDRCmdCtrl, FIF_DDRCmdCtrl_VAL_2, r1)

	SET_BASEREG(r0, SMU_BASE)

	// --- start PLL
	MOV	r7,	#(SMU_PLLSEL_STATE_MASK)

	STORE_WORD(r0, SMU_PLLLOCKTIME, SMU_PLLLOCKTIME_VAL, r1)
#ifndef	PLL_192MHZ
	STORE_WORD(r0, SMU_PLL1CTRL0, SMU_PLL1CTRL0_VAL, r1)
	STORE_WORD(r0, SMU_PLL1CTRL1, SMU_PLL1CTRL1_VAL, r1)
#endif
	STORE_WORD(r0, SMU_PLL1CTRL2, SMU_PLL1CTRL2_VAL, r1)
	SET_BASEREG(r1, SMU_PLLSEL_VAL)
	nop
	nop
	nop
	nop

	b	1f
	
	// --- Wait for PLL

	.align	ICACHE_LINE_SIZE_ORD
1:
	STR	r1, [r0, #(SMU_PLLSEL & 0xfff)]

CLK192_WAIT:
	LDR	r6, [r0, #(SMU_PLLSEL & 0xfff)]
	AND	r6, r6,	r7			// r6 <= r6 & r7
	CMP	r6, #(SMU_PLLSEL_VAL & SMU_PLLSEL_STATE_MASK)
	NOP
	BNE	CLK192_WAIT

#ifndef	PLL_192MHZ
	STORE_WORD(r0, SMU_PLL3CTRL1, SMU_PLL3CTRL1_VAL, r1)
#endif	// !PLL_192MHZ

	STORE_WORD(r0, SMU_LCD_PLLSEL, SMU_LCD_PLLSEL_VAL, r1)
	STORE_WORD(r0, SMU_DIVLCDLCLK, SMU_DIVLCDLCLK_VAL, r1)
	STORE_WORD(r0, SMU_CLKEN_POL, SMU_CLKEN_POL_VAL, r1)

	SET_BASEREG(r0, LCD_BASE)
	STORE_WORD(r0, LCD_CONTROL, LCD_CONTROL_VAL, r1)

	//;; for UART console

	SET_BASEREG(r0, SMU_BASE)

	STORE_WORD(r0, SMU_RESETREQ0ENA, SMU_RESETREQ0ENA_AB1, r1)
	STORE_WORD(r0, SMU_RESETREQ0, SMU_RESETREQ0_VAL, r1)

	STORE_WORD(r0, SMU_DIVU70SCLK, SMU_DIVU70SCLK_VAL, r1)
	STORE_WORD(r0, SMU_DIVU71SCLK, SMU_DIVU71SCLK_VAL, r1)
	STORE_WORD(r0, SMU_DIVU72SCLK, SMU_DIVU72SCLK_VAL, r1)

	STORE_WORD(r0, SMU_UART_PLLSEL, SMU_UART_PLLSEL_VAL, r1)
	STORE_WORD(r0, SMU_IOCTRL, SMU_IOCTRL_VAL, r1)

	STORE_WORD(r0, SMU_AB1_U70WAITCTRL, SMU_AB1_U70WAITCTRL_VAL, r1)
	STORE_WORD(r0, SMU_AB1_U71WAITCTRL, SMU_AB1_U71WAITCTRL_VAL, r1)
	STORE_WORD(r0, SMU_AB1_U72WAITCTRL, SMU_AB1_U72WAITCTRL_VAL, r1)

	STORE_WORD(r0, SMU_RESETREQ0ENA, \
			(SMU_RESETREQ0ENA_U70 | \
			 SMU_RESETREQ0ENA_U71 | \
			 SMU_RESETREQ0ENA_U72), r1)

	STORE_WORD(r0, SMU_RESETREQ0, SMU_RESETREQ0_VAL, r1)


#ifndef NO_AUTOPWRCTRL
	/* Enable Automatic Clock Control */
	SET_BASEREG(r0, SMU_BASE)
	STORE_WORD(r0, SMU_APBCLKCTRL, SMU_APBCLKCTRL_VAL, r1)
	STORE_WORD(r0, SMU_AHBCLKCTRL0, SMU_AHBCLKCTRL0_VAL, r1)
	STORE_WORD(r0, SMU_AHBCLKCTRL1, SMU_AHBCLKCTRL1_VAL, r1)
	STORE_WORD(r0, SMU_CLKCTRL, SMU_CLKCTRL_VAL, r1)
#else	// !NO_AUTOPWRCTRL
	SET_BASEREG(r0, SMU_BASE)
#endif	// !NO_AUTOPWRCTRL

	/* Auto Frequency Change */
	STORE_WORD(r0, SMU_AUTO_FREQ_CHANGE, SMU_AUTO_FREQ_CHANGE_VAL, r1)

	STORE_WORD(r0, SMU_DSP_ADDRCONV, SMU_DSP_ADDRCONV_VAL, r1)
/*
 * Initialize On Board Devices
 */
	/* release Ethernet controller RESET */
	SET_BASEREG(r0, EBC_BASE)
	STORE_WORD(r0, EBC_LAN_RST, EBC_LAN_RST_VAL, r1)

	// Disable ICache to avoid cache aliases
	mov	r1, #0x1000
	mvn	r1, r1
	mrc	p15, 0, r0, c1, c0, 0
	and	r0, r0, r1
	mcr	p15, 0, r0, c1, c0, 0

//// -------------------------------------------------------------------------
5:	
	mov	pc, lr

.Lreset_pe12:
	SET_BASEREG(r1, PERIPHERAL_INIT_BASE)
	add	r1, r1, #(PERIPHERAL_INIT_PE1 & 0xf00)
	add	r1, r1, #(PERIPHERAL_INIT_PE1 & 0xff)
	cmp	r0, #1
	beq	_wait_peripheral
	add	r1, r1, #(PERIPHERAL_INIT_PE2 & 0x00ff)
_wait_peripheral:
	ldr	r0, [r1]
	cmp	r0, #PERIPHERAL_FINISH
	beq	_wait_peripheral_out
	mov	r0, #PERIPHERAL_NOT_YET
	str	r0, [r1]
_wait_peripheral_loop:
	ldr	r0, [r1]
	cmp	r0, #PERIPHERAL_FINISH
	bne	_wait_peripheral_loop
_wait_peripheral_out:	
	b	5b

END_INIT_FUNC (platformsetup)

//// -------------------------------------------------------------------------
//// -------------------------------------------------------------------------
//// -------------------------------------------------------------------------

BEGIN_INIT_FUNC (boot_pll_to_warmboot)
	// Enable ICache to prevent fetches under delay-control operations
	mrc	p15, 0, r0, c1, c0, 0
	orr	r0, r0, #0x1000
	mcr	p15, 0, r0, c1, c0, 0

	// --- stop NMI to dsp
	SET_BASEREG(r0, REG_PID)
	mov	r1, #(SWT_PE0_INT_MASK_SET_VAL)
	str	r1, [r0, #(SWT_PE0_INT_MASK_SET & 0xfff)]

	SET_BASEREG(r0, SMU_BASE)
	
	// --- relase reset
        MVN     r1, #0x00000000
        STR     r1, [r0, #(SMU_RESETREQ0ENA & 0x00ff)]
        STR     r1, [r0, #(SMU_RESETREQ1ENA & 0x00ff)]
	STORE_WORD(r0, SMU_RESETREQ0, SMU_RESETREQ0_RSM_VAL, r1)
	STORE_WORD(r0, SMU_RESETREQ1, SMU_RESETREQ1_VAL, r1)
	
	/* Disable unused clock lines */
#ifdef	ONDEMAND_CLK
	SET_BASEREG(r3, SWT_BASE)
	STORE_WORD(r3, SWT_TRACE_CLK, SWT_TRACE_CLK_VAL, r1)

	STORE_WORD(r0, SMU_GCLKCTRL0ENA, SMU_GCLKCTRL0ENA_RSM_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL0, SMU_GCLKCTRL0_RSM_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL0ENA, SMU_GCLKCTRL0ENA_VAL_CLR, r1)

	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRL1ENA_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1, SMU_GCLKCTRL1_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL1ENA, SMU_GCLKCTRL1ENA_VAL_CLR, r1)

	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_RSM_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2, SMU_GCLKCTRL2_RSM_VAL_ONDEMAND, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_VAL_CLR, r1)

#else	// ONDEMAND_CLK
	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_VAL_SI1, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2, SMU_GCLKCTRL2_VAL_SI1, r1)
	STORE_WORD(r0, SMU_GCLKCTRL2ENA, SMU_GCLKCTRL2ENA_VAL_CLR, r1)
#endif // ONDEMAND_CLK
		
	// --- set SDRAM timigs to meet PLL192MHz
	STORE_WORD(r0, SMU_DDR_M1CLKR_DLY, SMU_DDR_M1CLKR_DLY_VAL, r1)
# ifdef	PLL_192MHZ
	STORE_WORD(r0, SMU_DDR_M4CLKW_DLY, SMU_DDR_M4CLKW_DLY_VAL, r1)
# endif
	STORE_WORD(r0, SMU_DDR_MCLK_DLY, SMU_DDR_MCLK_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_DQSOUT_DLY, SMU_DDR_DQSOUT_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_DQSOUT12M_DLY, SMU_DDR_DQSOUT12M_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_DQS_I_DLY, SMU_DDR_DQS_I_DLY_VAL, r1)
	STORE_WORD(r0, SMU_DDR_M1CLKR_ST, SMU_DDR_M1CLKR_ST_VAL, r1)

	STORE_WORD(r0, SMU_BUFSEL1, SMU_BUFSEL1_VAL, r1)

	SET_BASEREG	(r0, FIF_DDR_BASE)
#if 1	// no needs for elpida DDR
	STORE_WORD(r0, FIF_DDRConfigB, FIF_DDRConfigB_VAL, r1)
#endif
	STORE_WORD(r0, FIF_DDRConfigA, FIF_DDRConfigA_VAL, r1)
	STORE_WORD(r0, FIF_DDRPowerMng, FIF_DDRPowerMng_VAL, r1)
	STORE_WORD(r0, FIF_DDRModeReg, FIF_DDRModeReg_VAL, r1)
	STORE_WORD(r0, FIF_DDRCmdCtrl, FIF_DDRCmdCtrl_VAL_RSME1, r1)

	// --- wait for DDR
	
	MOV		r1, #0x00000000
DDRINITWAIT_R:
	ADD		r1, r1, #1
	CMP		r1, #4096
	NOP
	BNE		DDRINITWAIT_R

#if 0
	STORE_WORD(r0, FIF_DDRCmdCtrl, FIF_DDRCmdCtrl_VAL_RSME2, r1)
#endif
		
	SET_BASEREG(r0, SMU_BASE)

	// --- start PLL

	MOV	r7,	#(SMU_PLLSEL_STATE_MASK)

	STORE_WORD(r0, SMU_PLLLOCKTIME, SMU_PLLLOCKTIME_VAL, r1)
#ifndef	PLL_192MHZ
	STORE_WORD(r0, SMU_PLL1CTRL0, SMU_PLL1CTRL0_VAL, r1)
	STORE_WORD(r0, SMU_PLL1CTRL1, SMU_PLL1CTRL1_VAL, r1)
#endif	// !PLL_192MHZ
	STORE_WORD(r0, SMU_PLL1CTRL2, SMU_PLL1CTRL2_VAL, r1)
	SET_BASEREG(r1, SMU_PLLSEL_VAL)
	nop
	nop
	nop
	nop

	b	1f
	
	// --- Wait for PLL

	.align	ICACHE_LINE_SIZE_ORD
1:
	STR	r1, [r0, #(SMU_PLLSEL & 0xfff)]

CLK192_WAIT_R:
	LDR	r6, [r0, #(SMU_PLLSEL & 0xfff)]
	AND	r6, r6,	r7			// r6 <= r6 & r7
	CMP	r6, #(SMU_PLLSEL_VAL & SMU_PLLSEL_STATE_MASK)
	NOP
	BNE	CLK192_WAIT_R

#ifndef	PLL_192MHZ
	STORE_WORD(r0, SMU_PLL3CTRL1, SMU_PLL3CTRL1_VAL, r1)
#endif	// !PLL_192MHZ

	
	//;; for UART console

	SET_BASEREG(r0, SMU_BASE)

	STORE_WORD(r0, SMU_RESETREQ0ENA, SMU_RESETREQ0ENA_AB1, r1)
	STORE_WORD(r0, SMU_RESETREQ0, SMU_RESETREQ0_RSM_VAL, r1)

	STORE_WORD(r0, SMU_DIVU70SCLK, SMU_DIVU70SCLK_VAL, r1)
	STORE_WORD(r0, SMU_DIVU71SCLK, SMU_DIVU71SCLK_VAL, r1)
	STORE_WORD(r0, SMU_DIVU72SCLK, SMU_DIVU72SCLK_VAL, r1)

	STORE_WORD(r0, SMU_UART_PLLSEL, SMU_UART_PLLSEL_VAL, r1)
	STORE_WORD(r0, SMU_IOCTRL, SMU_IOCTRL_VAL, r1)

	STORE_WORD(r0, SMU_AB1_U70WAITCTRL, SMU_AB1_U70WAITCTRL_VAL, r1)
	STORE_WORD(r0, SMU_AB1_U71WAITCTRL, SMU_AB1_U71WAITCTRL_VAL, r1)
	STORE_WORD(r0, SMU_AB1_U72WAITCTRL, SMU_AB1_U72WAITCTRL_VAL, r1)

	STORE_WORD(r0, SMU_RESETREQ0ENA, \
			(SMU_RESETREQ0ENA_U70 | \
			 SMU_RESETREQ0ENA_U71 | \
			 SMU_RESETREQ0ENA_U72), r1)

	STORE_WORD(r0, SMU_RESETREQ0, SMU_RESETREQ0_RSM_VAL, r1)

#ifndef NO_AUTOPWRCTRL
	/* Enable Automatic Clock Control */
	SET_BASEREG(r0, SMU_BASE)
	STORE_WORD(r0, SMU_APBCLKCTRL, SMU_APBCLKCTRL_VAL, r1)
	STORE_WORD(r0, SMU_AHBCLKCTRL0, SMU_AHBCLKCTRL0_VAL, r1)
	STORE_WORD(r0, SMU_AHBCLKCTRL1, SMU_AHBCLKCTRL1_VAL, r1)
	STORE_WORD(r0, SMU_CLKCTRL, SMU_CLKCTRL_VAL, r1)
#else	// !NO_AUTOPWRCTRL
	SET_BASEREG(r0, SMU_BASE)
#endif	// !NO_AUTOPWRCTRL

	/* Auto Frequency Change */
	STORE_WORD(r0, SMU_AUTO_FREQ_CHANGE, SMU_AUTO_FREQ_CHANGE_VAL, r1)

	// Disable ICache to avoid cache aliases
	mov	r1, #0x1000
	mvn	r1, r1
	mrc	p15, 0, r0, c1, c0, 0
	and	r0, r0, r1
	mcr	p15, 0, r0, c1, c0, 0

//// -------------------------------------------------------------------------
	mov	pc, lr

        .end

#endif


