/*
 * (C) Copyright 2005-2006 NEC Electronics Corporation
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#include <config.h>
#include "boot.h"
#include "uwire.h"

#define TIMER_12MHZ_BOOT	// MP211 QueensES,MCT0501,GHIDORA

#ifdef CONFIG_MP201
//; --- SRAM regin
#ifdef CONFIG_MP200_MINI_BOARD
#define MP200_SSRAM_BASE		0xA0000000	/* Bank10 */
#define MP200_SSRAM_SIZE		0x00040000	/* 256KB */

//#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM0
//#define	WARM_BOOT_HANDLER_STACKBOTTOM0	(MP200_SSRAM_BASE + MP200_SSRAM_SIZE - 4)
//#endif
#ifndef WARM_BOOT_HANDLER_ENTRY0
 #ifdef WARMBOOT_SRAM
  #define WARM_BOOT_HANDLER_ENTRY0  (MP200_SSRAM_BASE + MP200_SSRAM_SIZE - 0x1000)
 #else
  #define WARM_BOOT_HANDLER_ENTRY0  (MP200_SSRAM_BASE + MP200_SSRAM_SIZE - 0x0800)
 #endif
#endif

#else	/* MCT Board */
//#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM0
//#define	WARM_BOOT_HANDLER_STACKBOTTOM0	0x32000ffc
//#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY0
#define	WARM_BOOT_HANDLER_ENTRY0	0x32000100
#endif
#endif	/* MCT Board end */

#define	SMU_RESET_STATE			0xC8010280
#define WARM_BOOT_FLG			0x00000001

#define PWC_PSCNT_ADD           0x06
#define PWC_IOSEL1_ADD          0x10
#define PWC_IOOUT1_ADD          0x14

#define PWC_PSCNTGP2_DATA       0x01
#define PWC_P7ON_DATA           0x80
#define PWC_P7ON_DATA_RSM       0xF0
#define PWC_LANRST_CLR          0x00
#else
//; --- SRAM regin
#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM0
#define	WARM_BOOT_HANDLER_STACKBOTTOM0	0xa007fffc
#endif
#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM1
#define	WARM_BOOT_HANDLER_STACKBOTTOM1	0xa007fefc
#endif
#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM2
#define	WARM_BOOT_HANDLER_STACKBOTTOM2	0xa007fdfc
#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY0
#define	WARM_BOOT_HANDLER_ENTRY0	0xa007f000
#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY1
#define	WARM_BOOT_HANDLER_ENTRY1	0xa007f200
#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY2
#define	WARM_BOOT_HANDLER_ENTRY2	0xa007f400
#endif

#ifndef PE12_SUSPEND_FLAG
#define PE12_SUSPEND_FLAG		0xa009f1fc
#endif

#define PWC_PWR_CNT_HOLD_CLR		0x2a
#define PWC_PWR_CNT_HOLD_R		0x2b
#define	PWC_PWR_CNT_HOLD_R_LOGIC0_EN	0x1
#endif
#define	UWIRE_CS0			0

/* 2006.04.25 fuj : For RICOH RF5T735 */
#ifdef CONFIG_ICX1087
#define PWC_PWR_REGA_R      0x02
#define PWC_PWR_PSCNT1_R    0x04
#define PWC_PWR_PSCNT2_R    0x06
#define PWC_PWR_MODESET1_R  0x08
#define PWC_PWR_VOUTSET1_R  0x0A
#define PWC_PWR_VOUTSET2_R  0x0C
#define PWC_PWR_VOUTSET3_R  0x0E
/* 2006.11.17 fuj : set GPIO13 to HIGH */
#define PWC_GPIO_IOSEL2     0x12
#define PWC_GPIO_IOOUT2     0x16
/* 2006.11.24 fuj : set GPPUPD */
#define PWC_GPIO_GPPUPD1    0x18
#define PWC_GPIO_GPPUPD2    0x1A
#define PWC_GPIO_GPPUPD3    0x1C
#define PWC_GPIO_GPPUPD4    0x1E
#define PWC_INTC_FMASK1     0x20
#define PWC_INTC_FMASK2     0x22
#define PWC_INTC_FMASK3     0x24
#define PWC_INTC_STATE1     0x26
#define PWC_INTC_CLRFACT1   0x2C
#define PWC_INTC_CLRFACT2   0x2E
#define PWC_INTC_CLRFACT3   0x30
#define PWC_INTC_BMASK1     0x3E
#define PWC_INTC_BMASK2     0x40
#define PWC_INTC_BMASK3     0x42
#define PWC_INTC_PWONMASK   0x4C
#define	PWC_LSIVER			0x6F

/* wait 1ms */
/* 2006.06.30 fuj : For NAND boot */
#ifdef CONFIG_NANDBOOT
#define	PWC_WAIT()	{				\
	register int cnt;				\
	for(cnt=0; cnt<24800; cnt++);	\
}
#else
#define	PWC_WAIT()	{				\
	register int cnt;				\
	for(cnt=0; cnt<6; cnt++);	\
}
#endif /* CONFIG_NANDBOOT */
#endif /* CONFIG_ICX1087 */

#define TI0_OP				0xC0000000
#define TI0_SET				0xC0000008
#ifdef CONFIG_MP201
#define T0TIN_SEL			0xC8010120
#else
#define T0TIN_SEL			0xC801013C
#endif

/*
 * SyncBurst Mode flag
 */
#ifdef CONFIG_MP201
#define SYNCBURST_MODE_ADDR	0xa003fa00
#else
#define SYNCBURST_MODE_ADDR	0xa007fa00
#endif
#define SYNCBURST_TRUE		0xffffffff
#define SYNCBURST_FALSE		0x00000000

/* 2006.06.09 fuj : For NAND boot */
#if defined(CONFIG_ICX1087) && defined(CONFIG_NANDBOOT)
void __attribute__ ((unused,section (".text")))
#else
void __attribute__ ((unused,section (".init.text")))
#endif  /* CONFIG_ICX1087 && CONFIG_NANDBOOT */
boot_check(void)
{
#ifdef CONFIG_MP201
#ifdef TIMER_12MHZ_BOOT
    register volatile unsigned int *base __asm__ ("r3");
    base = (volatile unsigned int *)TI0_OP;
    *base = 0x0;
    base = (volatile unsigned int *)TI0_SET;
    *base = (120000-1);
    base = (volatile unsigned int *)T0TIN_SEL;
    *base = 0x0;
    base = (volatile unsigned int *)TI0_OP;
    *base = 0x7;
#endif
    register unsigned int b_state __asm__ ("r0");
    base = (volatile unsigned int *)SMU_RESET_STATE;
    b_state = *base;			/* get boot flag */
    if ((b_state & WARM_BOOT_FLG) != 0 ) {
	/* warm boot */
#ifdef WARMBOOT_SRAM
#else
        __asm__ __volatile__ ("bl boot_pll_to_warmboot\t@ dispose old lr");
#endif
//	__asm__ __volatile__ ("mov\tsp, %0\t@ stack base of warm boot"
//		      :: "r" (WARM_BOOT_HANDLER_STACKBOTTOM0));
	__asm__ __volatile__ ("mov\tpc, %0\t@ jump to warm boot handler"
		      :: "r" (WARM_BOOT_HANDLER_ENTRY0));
    } else {
        /* cold boot */
/* 2006.04.25 fuj : For RICOH RF5T735 */
#ifdef CONFIG_ICX1087
        uwire_init();
/* 2006.10.19 fuj : Added to apply LSIVER.3 */
		if (uwire_read(UWIRE_CS0, PWC_LSIVER) >= 0x03) {
/* 2007.07.13 fuj : for TMD LCD */
#ifdef CONFIG_ICX1111
        	uwire_write(UWIRE_CS0, PWC_PWR_PSCNT1_R, 0x08);
        	uwire_write(UWIRE_CS0, PWC_PWR_PSCNT1_R, 0x0A);
			PWC_WAIT();
        	uwire_write(UWIRE_CS0, PWC_PWR_PSCNT1_R, 0x0E);
#else
        	uwire_write(UWIRE_CS0, PWC_PWR_PSCNT1_R, 0x02);
			PWC_WAIT();
        	uwire_write(UWIRE_CS0, PWC_PWR_PSCNT1_R, 0x0E);
#endif
		}
		else {
        	uwire_write(UWIRE_CS0, PWC_PWR_PSCNT1_R, 0x0C);
		}
		PWC_WAIT();
/* 2006.11.30 fuj : set REGGP4 ON when LCDC will be initialized */
/*        uwire_write(UWIRE_CS0, PWC_PWR_PSCNT2_R, 0x06); */
        uwire_write(UWIRE_CS0, PWC_PWR_PSCNT2_R, 0x02);
		PWC_WAIT();
/* 2006.12.20 fuj : Deleted to set REGGP5 */
/* 2006.10.19 fuj : Added to set REGGP5 for SPI */
/* 2006.11.30 fuj : set REGGP4 ON when LCDC will be initialized */
/*         uwire_write(UWIRE_CS0, PWC_PWR_PSCNT2_R, 0x0E); */
/*         uwire_write(UWIRE_CS0, PWC_PWR_PSCNT2_R, 0x0A); */

/* 2006.11.27 fuj : modified voltage */
/*        uwire_write(UWIRE_CS0, PWC_PWR_VOUTSET1_R, 0xA2); */
/*        uwire_write(UWIRE_CS0, PWC_PWR_VOUTSET2_R, 0x60); */ 
        uwire_write(UWIRE_CS0, PWC_PWR_VOUTSET1_R, 0xA3);
        uwire_write(UWIRE_CS0, PWC_PWR_VOUTSET2_R, 0xA8);
/* 2006.11.06 fuj : Set REGANA=2.85V for ES2.02 */
		if (uwire_read(UWIRE_CS0, PWC_LSIVER) >= 0x03)
	        uwire_write(UWIRE_CS0, PWC_PWR_VOUTSET3_R, 0x00);
		else if (uwire_read(UWIRE_CS0, PWC_LSIVER) >= 0x02)
	        uwire_write(UWIRE_CS0, PWC_PWR_VOUTSET3_R, 0x20);
		else
        	uwire_write(UWIRE_CS0, PWC_PWR_VOUTSET3_R, 0x2C);
        uwire_write(UWIRE_CS0, PWC_INTC_STATE1, 0x00);
        uwire_write(UWIRE_CS0, PWC_INTC_FMASK1, 0x00);
        uwire_write(UWIRE_CS0, PWC_INTC_FMASK2, 0x00);
        uwire_write(UWIRE_CS0, PWC_INTC_FMASK3, 0x00);
        uwire_write(UWIRE_CS0, PWC_INTC_BMASK1, 0x00);
        uwire_write(UWIRE_CS0, PWC_INTC_BMASK2, 0x00);
        uwire_write(UWIRE_CS0, PWC_INTC_BMASK3, 0x00);
/* 2006.09.07 fuj : FACT1,3 will be referred at displaying LCD */
/*        uwire_write(UWIRE_CS0, PWC_INTC_CLRFACT1, 0xFF); */
        uwire_write(UWIRE_CS0, PWC_INTC_CLRFACT2, 0xFF);
/* 2007.04.24 zha CRTCINT should not be cleared for RTC alarm interrupt */
        uwire_write(UWIRE_CS0, PWC_INTC_CLRFACT3, 0xFD);
        uwire_write(UWIRE_CS0, PWC_INTC_PWONMASK, 0x00);
/* 2006.11.24 fuj : set GPPUPD */
        uwire_write(UWIRE_CS0, PWC_GPIO_GPPUPD1, 0x50);
        uwire_write(UWIRE_CS0, PWC_GPIO_GPPUPD2, 0x01);
        uwire_write(UWIRE_CS0, PWC_GPIO_GPPUPD3, 0x55);
        uwire_write(UWIRE_CS0, PWC_GPIO_GPPUPD4, 0x01);
/* 2006.11.17 fuj : set GPIO13(CHG_ICTL) to HIGH */
        uwire_write(UWIRE_CS0, PWC_GPIO_IOSEL2, 0x20);
        uwire_write(UWIRE_CS0, PWC_GPIO_IOOUT2, 0x20);
        uwire_exit();
#endif /* CONFIG_ICX1087 */
    }
#else	/* end CONFIG_MP201 */
    register unsigned int self_pe __asm__ ("r0");

    /* check the number of PE */
    self_pe = *(unsigned int volatile *)0x80000000;
    if ( self_pe == 0 ) {

	/* check warmboot or not */
	if (uwire_check_resetcontrol() != 0) {
#ifdef TIMER_12MHZ_BOOT
	    register volatile unsigned int *base __asm__ ("r3");
	    base = (volatile unsigned int *)TI0_OP;
	    *base = 0x0;
	    base = (volatile unsigned int *)TI0_SET;
	    *base = (120000-1);
	    base = (volatile unsigned int *)T0TIN_SEL;
	    *base = 0x0;
	    base = (volatile unsigned int *)TI0_OP;
	    *base = 0x7;
#endif
	    uwire_init();
	    register unsigned int i __asm__ ("r3");
	    i = uwire_read(UWIRE_CS0, PWC_PWR_CNT_HOLD_R);
	    uwire_write(UWIRE_CS0, PWC_PWR_CNT_HOLD_CLR, 1);	/* VL1 CLR */
	    uwire_exit();
	    if ((i & PWC_PWR_CNT_HOLD_R_LOGIC0_EN) != 0 ) {
		/* warm boot */
	        __asm__ __volatile__ ("bl boot_pll_to_warmboot\t@ dispose old lr");
		i = *((volatile unsigned long *)SYNCBURST_MODE_ADDR);
		if ( i == SYNCBURST_TRUE ) {
		  __asm__ __volatile__ ("bl set_flash_burst\t@ dispose old lr");
		}
		__asm__ __volatile__ ("mov\tsp, %0\t@ stack base of warm boot"
			      :: "r" (WARM_BOOT_HANDLER_STACKBOTTOM0));
		__asm__ __volatile__ ("mov\tpc, %0\t@ jump to warm boot handler"
			      :: "r" (WARM_BOOT_HANDLER_ENTRY0));
	    } else {
	        /* cold boot */
#if !defined(CONFIG_MP200_MINI_BOARD)
	        __asm__ __volatile__ ("b init_checkfield_by_pe0\t@ keep old lr");
#else
		init_checkfield_by_pe0();
#endif
	    }
	    /* not reached */
	}
    }
#endif
}

/* 2006.06.09 fuj : For NAND boot */
#if !defined(CONFIG_ICX1087)
#if (defined(CONFIG_MP201) && defined(CONFIG_MP200_MINI_BOARD))
void __attribute__ ((unused,section (".init.text")))
boot_LAN_RST(void)
{
    uwire_init();
    uwire_write(UWIRE_CS0, PWC_PSCNT_ADD, PWC_PSCNTGP2_DATA);   /* PWC REGGP2 -> on */
    uwire_write(UWIRE_CS0, PWC_IOSEL1_ADD, PWC_P7ON_DATA);	/* PWC GPIO P7 -> outport */
    uwire_write(UWIRE_CS0, PWC_IOOUT1_ADD, PWC_LANRST_CLR);	/* Release LAN RESET */
    uwire_exit();
}
#endif
#endif  /* !CONFIG_ICX1087 */

