/*
 * (C) Copyright 2005 NEC Electronics Corporation
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * Copyright 2006,2007 Sony Corporation. 
 */

#include "boot.h"
#include "uwire.h"
#include <config.h>

//; --- SRAM regin
#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM0
#define	WARM_BOOT_HANDLER_STACKBOTTOM0	0xa007fffc
#endif
#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM1
#define	WARM_BOOT_HANDLER_STACKBOTTOM1	0xa007fefc
#endif
#ifndef	WARM_BOOT_HANDLER_STACKBOTTOM2
#define	WARM_BOOT_HANDLER_STACKBOTTOM2	0xa007fdfc
#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY0
#define	WARM_BOOT_HANDLER_ENTRY0	0xa007f000
#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY1
#define	WARM_BOOT_HANDLER_ENTRY1	0xa007f200
#endif
#ifndef	WARM_BOOT_HANDLER_ENTRY2
#define	WARM_BOOT_HANDLER_ENTRY2	0xa007f400
#endif

#ifndef PE1_SUSPEND_FLAG
#define PE1_SUSPEND_FLAG		0xa007f1fc
#endif
#ifndef PE2_SUSPEND_FLAG
#define PE2_SUSPEND_FLAG		0xa007f3fc
#endif

/* 2006.06.09 fuj : For NAND boot */
#if defined(CONFIG_ICX1087) && defined(CONFIG_NANDBOOT)
void __attribute__ ((unused,section (".text")))
#else
void __attribute__ ((unused,section (".init.text")))
#endif  /* CONFIG_ICX1087 && CONFIG_NANDBOOT */
boot_check12(void)
{
    register unsigned int self_pe __asm__ ("r0");

    /* check the number of PE */
    self_pe = *(unsigned int volatile *)0x80000000;
    if ( self_pe == 1 ) {
		register unsigned int i __asm__ ("r3");
		i = *(volatile unsigned int *)PE1_SUSPEND_FLAG;
		*(volatile unsigned int *)PE1_SUSPEND_FLAG = 0;
		if ((i & ~0xf) == 0) {
			if (i & 0x1 ) {
				__asm__ __volatile__ ("mov\tsp, %0\t@ stack base of warm boot"
					      :: "r" (WARM_BOOT_HANDLER_STACKBOTTOM1));
				__asm__ __volatile__ ("mov\tpc, %0\t@ jump to warm boot handler"
					      :: "r" (WARM_BOOT_HANDLER_ENTRY1));
			}
		}
    } else if ( self_pe == 2 ) {
		register unsigned int i __asm__ ("r3");
		i = *(volatile unsigned int *)PE2_SUSPEND_FLAG;
		*(volatile unsigned int *)PE2_SUSPEND_FLAG = 0;
		if ((i & ~0xf) == 0) {
			if (i & 0x1) {
				__asm__ __volatile__ ("mov\tsp, %0\t@ stack base of warm boot"
					      :: "r" (WARM_BOOT_HANDLER_STACKBOTTOM2));
				__asm__ __volatile__ ("mov\tpc, %0\t@ jump to warm boot handler"
					      :: "r" (WARM_BOOT_HANDLER_ENTRY2));
			}
		}
    }
}

/* 2006.06.09 fuj : For NAND boot */
#if defined(CONFIG_ICX1087) && defined(CONFIG_NANDBOOT)
void __attribute__ ((unused,section (".text")))
#else
void __attribute__ ((unused,section(".init.text")))
#endif  /* CONFIG_ICX1087 && CONFIG_NANDBOOT */
init_checkfield_by_pe0(void)
{
  register volatile unsigned int *p __asm__("r3");

  p = (volatile unsigned int *)PE1_SUSPEND_FLAG;
  *p = 0;
  p = (volatile unsigned int *)PE2_SUSPEND_FLAG;
  *p = 0;
}

